
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADCSR=6;     
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

unsigned char txt1 []="";
unsigned char txt2 []="";
unsigned char txt3 []="";
unsigned char txt4 []=". .";		
unsigned char txt5 []="M. . .";		
unsigned char txt6 []="";		
unsigned char txt7 []="";		
unsigned char txt8 []="";				
unsigned char txt9 []="";			
unsigned char txt10 []="";			
unsigned char txt11 []="..";			
unsigned char txt12[]="..";			
unsigned char txt13[]="";		
unsigned char txt14[]="";		
unsigned char txt15[]="--/--";				
unsigned char txt16[]=":";
unsigned char txt17[]=".";
unsigned char txt18[]=". ";
unsigned char txt19[]="1";
unsigned char txt20[]="2";
unsigned char txt21[]="3";
unsigned char txt22[]="";
unsigned char txt23[]="";

unsigned char txt24[]="Auto OFF";
unsigned char txt25[]="uto ON";
unsigned char txt26[]="( HEX)";	
unsigned char txt27[]="ADCRESULT   ";
unsigned char txt28[]=" ";
unsigned char txt29[]="AMBIENT  ";
unsigned char txt30[]="STAGE MAX AVERAGE";
unsigned char txt31[]="STAGE UP TRESHOULD";
unsigned char txt32[]="STAGE MIN AVERAGE";
unsigned char txt33[]="STAGE LOW TRESHOULD";
unsigned char txt34[]=".  (0-7)";
unsigned char txt35[]=" .";
unsigned char txt36[]="";
unsigned char txt37[]="";
unsigned char txt38[]=". ";

unsigned char txt39[]="  AD7142";
unsigned char txt40[]=" ";
unsigned char txt41[]=" ";
unsigned char txt42[]=", ";
unsigned char txt43[]=" ";

volatile unsigned char clock;
volatile unsigned char mig_att;
volatile unsigned char displ_refresh=1;	
volatile unsigned char h,m,s;			
volatile unsigned char hour,min,sec;		
volatile unsigned char date, mounth, year;	
volatile unsigned char rem_command;	
volatile unsigned char command_tx=10;	
volatile unsigned int volume;			
volatile unsigned int volume_displ;
volatile eeprom unsigned int volume_ogr=30;	

volatile unsigned int volume_ogr_displ;		

volatile eeprom unsigned char valcoder_sens=1;	
volatile eeprom unsigned char n_valc_imp=5;	
volatile unsigned char valcoder_PLUS;		
volatile unsigned char valcoder_MINUS;		

volatile eeprom unsigned int save_volume=44;	
volatile eeprom unsigned int volume_on_max=30;	
volatile unsigned int volume_on_max_displ;	
volatile unsigned char tek_menu=0;		
volatile eeprom unsigned char tek_vhod=1;	
volatile unsigned int loud_displ;		
volatile eeprom unsigned int att=25;		
volatile unsigned int att_displ;		
volatile unsigned char att_on=0;		

volatile unsigned int loudness=0;	
volatile unsigned char treble=7;	
volatile unsigned char  bass=7;		

volatile eeprom unsigned char treble1=7;	
volatile eeprom unsigned char treble2=7;	
volatile eeprom unsigned char treble3=7;	
volatile eeprom unsigned char  bass1=7;		
volatile eeprom unsigned char  bass2=7;		
volatile eeprom unsigned char  bass3=7;		
volatile eeprom unsigned int loudness1=0;	
volatile eeprom unsigned int loudness2=0;	
volatile eeprom unsigned int loudness3=0;	

volatile unsigned char Refr1=0;		
volatile unsigned char Refr2=0;		
volatile unsigned char Refr3=0;		
volatile unsigned char Refr4=0;		
volatile unsigned char Refr30=0;		

volatile unsigned char menu30=0;		
volatile unsigned char menu30_2=0;		

volatile unsigned char  timer=0;

volatile unsigned char  adr=0;		

volatile char treble_disp;			
volatile char bass_disp;			
volatile unsigned char tog_ch=0;		
volatile eeprom unsigned char min_off=0;	
volatile eeprom unsigned char hour_off=0;
volatile eeprom unsigned char min_on=0;
volatile eeprom unsigned char hour_on=0;

volatile unsigned char buffer[24];		
volatile unsigned char buf[4];		
volatile unsigned char amp_on_act=0;		
volatile unsigned char amp_off_act=0;		
volatile eeprom unsigned char  first_run=0;
volatile unsigned char system_on=0;		
volatile eeprom unsigned char DS=12;		
volatile unsigned char com;			

volatile unsigned int stage=0;	
volatile unsigned int stage_temp=0;

volatile unsigned int address_temp=0;	
volatile unsigned char menu_temp=0;	
volatile unsigned int res_temp=0;	

volatile unsigned char d_count=0;	

volatile long int res_long;
volatile long int adr_long;

volatile unsigned char dig1=0;
volatile unsigned char dig2=0;
volatile unsigned char dig3=0;
volatile unsigned char dig4=0;
volatile unsigned char dig5=0;

volatile unsigned int SLLI=0;	
volatile unsigned int SHLI=0;	
volatile unsigned int SCLI=0;	
volatile unsigned int EnableRecalAgain=0;
volatile unsigned int EnableRecalCounter=0;

volatile unsigned int temp=0;	

volatile unsigned char m1=0;

#pragma used+
unsigned char spi(unsigned char data);
#pragma used-

#pragma library spi.lib

void write_to_AD7142_spi(unsigned int address, unsigned int data) 
{

unsigned char MSB_stw;		
unsigned char LSB_stw;		
unsigned char MSB_data;		
unsigned char LSB_data;		
unsigned int start_word;		
#asm ("cli");
start_word = 57344|(address & 1023);		

LSB_stw=(unsigned char) start_word;		
MSB_stw=(unsigned char)(start_word>>8);	

PORTB &=~(1<<4);;	;		

LSB_data=(unsigned char) data;			
MSB_data=(unsigned char)(data>>8);		

spi(MSB_stw);
spi(LSB_stw);
spi(MSB_data);
spi(LSB_data);
PORTB |=(1<<4);;;		

#asm("sei");
}

unsigned int  read_from_AD7142_spi (unsigned int address) {  

unsigned char MSB_stw;		
unsigned char LSB_stw;		
unsigned int data;			
unsigned int start_word;		
#asm ("cli");
start_word = 58368|(address & 1023);		

LSB_stw=(unsigned char) start_word;		
MSB_stw=(unsigned char)(start_word>>8);	
PORTB &=~(1<<4);;	;		

spi(MSB_stw);		
spi(LSB_stw);		

data = spi(0);		
data = data<<8;		
data|= spi(0);		
PORTB |=(1<<4);;;		

return data;		
#asm("sei");
} 

void write_to_AD7142_spi_serial(unsigned int start_address,  eeprom unsigned int  mass[],unsigned char num_mass,  unsigned char counter) {

unsigned char q;			
unsigned int eeprom *sel;		
unsigned char MSB_stw;		
unsigned char LSB_stw;		
unsigned char MSB_data;		
unsigned char LSB_data;		
unsigned int data;			
unsigned int start_word;		
#asm ("cli");
start_word = 57344|(start_address & 1023);		
sel = mass;						

LSB_stw=(unsigned char) start_word;            
MSB_stw=(unsigned char)(start_word>>8);   
PORTB &=~(1<<4);;	;		
spi(MSB_stw);
spi(LSB_stw);

sel = &mass[num_mass];					
for (q=1; q<=counter; q++) {		
data=*sel;						

LSB_data=(unsigned char) data;		
MSB_data=(unsigned char)(data>>8);	
spi(MSB_data);					
spi(LSB_data);
sel++;						

}
PORTB |=(1<<4);;;		
#asm("sei");
}

eeprom unsigned int AD7142_Config []= {

2224,		
0,		    
12848,	    
5320,		
2098,		
0x0000,	    
0x0000,	    
0x0001,	    

0x3FFE,	    
0x3FFF,	    
0x500,	    
0x2626,	    
1000,		
1000,		
1500,		
1500,		

0x3FFF,	    
0x3FFF,	    
0,		    
0x2626,	    
1000,		
1000,		
1500,		
1500,		

0x3FFF,	    
0x3FFF,	    
0,		    
0x2626,	    
1000,		
1000,		
1500,		
1500,		

0x3FFF,	    
0x3FFF,	    
0,		    
0x2626,	    
1000,		
1000,		
1500,		
1500,		

0x3FFF,	    
0x3FFF,	    
0,		    
0x2626,	    
1000,		
1000,		
1500,		
1500,		

0x3FFF,	    
0x3FFF,	    
0,		    
0x2626,	    
1000,		
1000,		
1500,		
1500,		

0x3FFF,	    
0x3FFF,	    
0,		    
0x2626,	    
1000,		
1000,		
1500,		
1500,		

0x3FFF,	    
0x3FFF,	    
0,		    
0x2626,	    
1000,		
1000,		
1500,		
1500,		

0x3FFF,	    
0x3FFF,	    
0,		    
0x2626,	    
1000,		
1000,		
1500,		
1500,		

0x3FFF,	    
0x3FFF,	    
0,		    
0x2626,	    
1000,		
1000,		
1500,		
1500,		

0x3FFF,	    
0x3FFF,	    
0,		    
0x2626,	    
1000,		
1000,		
1500,		
1500,		

0x3FFF,	    
0x3FFF,	    
0,		    
0x2626,	    
1000,		
1000,		
1500,		
1500		
};

void AD7142_configure (void) {
read_from_AD7142_spi (23);		
write_to_AD7142_spi_serial(128,AD7142_Config, 8,96);		
write_to_AD7142_spi_serial(0,AD7142_Config, 0,8);		
write_to_AD7142_spi(1, 4095);		
read_from_AD7142_spi (8);
read_from_AD7142_spi (9);
read_from_AD7142_spi (10);
}

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
char *strtok(char *str1,char flash *str2);

unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);
unsigned int strcspn(char *str,char *set);
unsigned int strcspnf(char *str,char flash *set);
int strpos(char *str,char c);
int strrpos(char *str,char c);
unsigned int strspn(char *str,char *set);
unsigned int strspnf(char *str,char flash *set);

#pragma used-
#pragma library string.lib

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#pragma used+
void i2c_init(void);
unsigned char i2c_start(void);
void i2c_stop(void);
unsigned char i2c_read(unsigned char ack);
unsigned char i2c_write(unsigned char data);
#pragma used-

#pragma used+

unsigned char rtc_read(unsigned char address);
void rtc_write(unsigned char address,unsigned char data);
void rtc_init(unsigned char rs,unsigned char sqwe,unsigned char out);
void rtc_get_time(unsigned char *hour,unsigned char *min,unsigned char *sec);
void rtc_set_time(unsigned char hour,unsigned char min,unsigned char sec);
void rtc_get_date(unsigned char *date,unsigned char *month,unsigned char *year);
void rtc_set_date(unsigned char date,unsigned char month,unsigned char year);

#pragma used-
#pragma library ds1307.lib

#asm                                        
   .equ __i2c_port=0x15 ;PORTC
   .equ __sda_bit=7
   .equ __scl_bit=6
#endasm

void init_controller (void)  {

PORTA=0b00000000;
DDRA=0b11111111;

PORTB=0b10010000;
DDRB=0b10111011;

PORTC=0b00000000;
DDRC=0b00111100;

PORTD=0b00011111;
DDRD=0b11100000;

TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

TCCR1A=0x00;
TCCR1B=0x0D;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x1E;
OCR1AL=0x84;
OCR1BH=0x00;
OCR1BL=0x00;

ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

GICR|=0xE0;
MCUCR=0x0D;
MCUCSR=0x40;
GIFR=0xE0;

SPCR=0x5C;
SPSR=0x00;

TIMSK=0x11;
ACSR=0x80;
SFIOR=0x00;

}

flash unsigned char symbols [160] [5]= {
{0x00,0x00,0x00,0x00,0x00},	
{0x00,0x00,0x4f,0x00,0x00},	
{0x00,0x07,0x00,0x07,0x00},	
{0x14,0x7f,0x14,0x7f,0x14},	
{0x24,0x2a,0x7f,0x2a,0x12},	
{0x23,0x13,0x08,0x64,0x62},	
{0x36,0x49,0x55,0x22,0x40},	
{0x00,0x05,0x03,0x00,0x00},	
{0x00,0x1c,0x22,0x41,0x00},	
{0x00,0x41,0x22,0x1c,0x00},	
{0x14,0x08,0x3E,0x08,0x14},	
{0x08,0x08,0x3E,0x08,0x08},	
{0x00,0x50,0x30,0x00,0x00},	
{0x08,0x08,0x08,0x08,0x08},	
{0x00,0x00,0x40,0x00,0x00},	
{0x20,0x10,0x08,0x04,0x02},	
{0x3e,0x51,0x49,0x45,0x3e},	
{0x00,0x42,0x7f,0x40,0x00},	
{0x42,0x61,0x51,0x49,0x46},	
{0x21,0x41,0x45,0x4b,0x31},	
{0x18,0x14,0x12,0x7f,0x10},	
{0x27,0x45,0x45,0x45,0x39},	
{0x3c,0x4a,0x49,0x49,0x30},	
{0x01,0x71,0x09,0x05,0x03},	
{0x36,0x49,0x49,0x49,0x36},	
{0x06,0x49,0x49,0x29,0x1e},	
{0x00,0x00,0x24,0x00,0x00},	
{0x00,0x56,0x36,0x00,0x00},	
{0x08,0x14,0x22,0x41,0x00},	
{0x14,0x14,0x14,0x14,0x14},	
{0x00,0x41,0x22,0x14,0x08},	
{0x02,0x01,0x51,0x09,0x06},	
{0x32,0x49,0x71,0x41,0x3e},	
{0x7e,0x11,0x11,0x11,0x7e},	
{0x7f,0x49,0x49,0x49,0x36},	
{0x3e,0x41,0x41,0x41,0x22},	
{0x7f,0x41,0x41,0x22,0x1c},	
{0x7f,0x49,0x49,0x49,0x41},	
{0x7f,0x09,0x09,0x09,0x01},	
{0x3e,0x41,0x49,0x49,0x3a},	
{0x7f,0x08,0x08,0x08,0x7f},	
{0x00,0x41,0x7f,0x41,0x00},	
{0x20,0x40,0x41,0x3f,0x01},	
{0x7f,0x08,0x14,0x22,0x41},	
{0x7f,0x40,0x40,0x40,0x40},	
{0x7f,0x02,0x0c,0x02,0x7f},	
{0x7f,0x04,0x08,0x10,0x7f},	
{0x3e,0x41,0x41,0x41,0x3e},	
{0x7f,0x09,0x09,0x09,0x06},	
{0x3e,0x41,0x51,0x21,0x5e},	
{0x7f,0x09,0x19,0x29,0x46},	
{0x46,0x49,0x49,0x49,0x31},	
{0x01,0x01,0x7f,0x01,0x01},	
{0x3f,0x40,0x40,0x40,0x3f},	
{0x1f,0x20,0x40,0x20,0x1f},	
{0x3f,0x40,0x70,0x40,0x3f},	
{0x63,0x14,0x08,0x14,0x63},	
{0x07,0x08,0x70,0x08,0x07},	
{0x61,0x51,0x49,0x45,0x43},	
{0x00,0x7F,0x41,0x41,0x00},	
{0x02,0x04,0x08,0x10,0x20},	
{0x00,0x41,0x41,0x7F,0x00},	
{0x04,0x02,0x01,0x02,0x04},	
{0x40,0x40,0x40,0x40,0x40},	
{0x20,0x54,0x54,0x54,0x78},	
{0x7F,0x48,0x44,0x44,0x38},	
{0x38,0x44,0x44,0x44,0x20},	
{0x38,0x44,0x44,0x48,0x7F},	
{0x38,0x54,0x54,0x54,0x18},	
{0x08,0x7E,0x09,0x01,0x02},	
{0x0C,0x52,0x52,0x52,0x3E},	
{0x7F,0x08,0x04,0x04,0x78},	
{0x00,0x44,0x7D,0x40,0x00},	
{0x20,0x40,0x44,0x3D,0x00},	
{0x7F,0x10,0x28,0x44,0x00},	
{0x00,0x41,0x7F,0x40,0x00},	
{0x7C,0x04,0x18,0x04,0x78},	
{0x7C,0x08,0x04,0x04,0x78},	
{0x38,0x44,0x44,0x44,0x38},	
{0x7C,0x14,0x14,0x14,0x08},	
{0x08,0x14,0x14,0x18,0x7C},	
{0x7C,0x08,0x04,0x04,0x08},	
{0x48,0x54,0x54,0x54,0x20},	
{0x04,0x3F,0x44,0x40,0x20},	
{0x3C,0x40,0x40,0x20,0x7C},	
{0x1C,0x20,0x40,0x20,0x1C},	
{0x3C,0x40,0x30,0x40,0x3C},	
{0x44,0x28,0x10,0x28,0x44},	
{0x0C,0x50,0x50,0x50,0x3C},	
{0x44,0x64,0x54,0x4C,0x44},	
{0x00,0x08,0x36,0x41,0x00},	
{0x00,0x00,0x7f,0x00,0x00},	
{0x00,0x41,0x36,0x08,0x00},	
{0x02,0x01,0x02,0x02,0x01},	
{0x7E,0x4B,0x4A,0x4B,0x42},	
{0x38,0x55,0x54,0x55,0x18},	
{0x7e,0x11,0x11,0x11,0x7e},	
{0x7f,0x49,0x49,0x49,0x33},	
{0x7f,0x49,0x49,0x49,0x36},	
{0x7f,0x01,0x01,0x01,0x03},	
{0xe0,0x51,0x4f,0x41,0xff},	
{0x7f,0x49,0x49,0x49,0x41},	
{0x77,0x08,0x7f,0x08,0x77},	
{0x41,0x49,0x49,0x49,0x36},	
{0x7f,0x10,0x08,0x04,0x7f},	
{0x7c,0x21,0x12,0x09,0x7c},	
{0x7f,0x08,0x14,0x22,0x41},	
{0x20,0x41,0x3f,0x01,0x7f},	
{0x7f,0x02,0x0c,0x02,0x7f},	
{0x7f,0x08,0x08,0x08,0x7f},	
{0x3e,0x41,0x41,0x41,0x3e},	
{0x7f,0x01,0x01,0x01,0x7f},	
{0x7f,0x09,0x09,0x09,0x06},	
{0x3e,0x41,0x41,0x41,0x22},	
{0x01,0x01,0x7f,0x01,0x01},	
{0x47,0x28,0x10,0x08,0x07},	
{0x1c,0x22,0x7f,0x22,0x1c},	
{0x63,0x14,0x08,0x14,0x63},	
{0x7f,0x40,0x40,0x40,0xff},	
{0x07,0x08,0x08,0x08,0x7f},	
{0x7f,0x40,0x7f,0x40,0x7f},	
{0x7f,0x40,0x7f,0x40,0xff},	
{0x01,0x7f,0x48,0x48,0x30},	
{0x7f,0x48,0x30,0x00,0x7f},	
{0x00,0x7f,0x48,0x48,0x30},	
{0x22,0x41,0x49,0x49,0x3e},	
{0x7f,0x08,0x3e,0x41,0x3e},	
{0x46,0x29,0x19,0x09,0x7f},	
{0x20,0x54,0x54,0x54,0x78},	
{0x3c,0x4a,0x4a,0x49,0x31},	
{0x7c,0x54,0x54,0x28,0x00},	
{0x7c,0x04,0x04,0x04,0x0c},	
{0xe0,0x54,0x4c,0x44,0xfc},	
{0x38,0x54,0x54,0x54,0x18},	
{0x6c,0x10,0x7c,0x10,0x6c},	
{0x44,0x44,0x54,0x54,0x28},	
{0x7c,0x20,0x10,0x08,0x7c},	
{0x7c,0x41,0x22,0x11,0x7c},	
{0x7c,0x10,0x28,0x44,0x00},	
{0x20,0x44,0x3c,0x04,0x7c},	
{0x7c,0x08,0x10,0x08,0x7c},	
{0x7c,0x10,0x10,0x10,0x7c},	
{0x38,0x44,0x44,0x44,0x38},	
{0x7c,0x04,0x04,0x04,0x7c},	
{0x7C,0x14,0x14,0x14,0x08},	
{0x38,0x44,0x44,0x44,0x00},	
{0x04,0x04,0x7c,0x04,0x04},	
{0x0C,0x50,0x50,0x50,0x3C},	
{0x30,0x48,0xfc,0x48,0x30},	
{0x44,0x28,0x10,0x28,0x44},	
{0x7c,0x40,0x40,0x40,0xfc},	
{0x0c,0x10,0x10,0x10,0x7c},	
{0x7c,0x40,0x7c,0x40,0x7c},	
{0x7c,0x40,0x7c,0x40,0xfc},	
{0x04,0x7c,0x50,0x50,0x20},	
{0x7c,0x50,0x50,0x20,0x7c},	
{0x7c,0x50,0x50,0x20,0x00},	
{0x28,0x44,0x54,0x54,0x38},	
{0x7c,0x10,0x38,0x44,0x38},	
{0x08,0x54,0x34,0x14,0x7c}	
};
flash unsigned char str_1[]={      
0,0,0,0,0,128,192,224,112,184,88,88,176,112,224,128,
128,254,255,171,85,171,85,171,85,171,85,171,87,255,254,128,
128,192,96,176,80,80,176,96,192,128,0,0,0,0,0,0,
0,0,0,28,63,115,237,210,173,82,173,213,234,245,122,63,
29,31,13,14,13,6,135,134,135,134,7,14,13,14,29,27,
61,114,245,234,149,171,84,171,210,109,51,30,8,0,0,0,
248,92,174,86,174,86,174,87,171,245,254,31,3,0,0,192,
248,124,14,7,3,3,3,1,1,3,3,3,7,14,60,248,
224,0,0,3,31,254,253,83,175,86,174,86,174,86,172,248,
31,53,106,117,106,117,106,245,218,47,255,248,192,0,0,3,
31,62,112,224,192,192,192,128,128,192,192,192,224,112,62,31,
3,0,0,192,248,127,175,213,250,117,106,117,106,117,122,31,
0,0,0,48,120,204,182,75,181,75,182,169,91,183,110,188,
216,184,112,176,112,224,97,225,97,225,96,240,176,112,184,216,
220,110,151,107,149,170,90,165,91,182,204,120,48,0,0,0,
0,0,0,0,0,0,1,3,6,13,26,26,13,6,3,1,
1,63,127,234,213,170,213,170,213,170,213,170,213,127,63,1,
1,3,6,13,26,26,13,6,3,1,0,0,0,0,0,0
};

flash unsigned char str_2[]={   
252,2,1,249,137,137,137,137,137,137,137,137,137,217,249,1,
1,1,249,9,9,9,9,9,9,9,9,9,89,249,1,1,
1,249,9,9,9,9,9,9,9,9,9,89,249,1,2,252,
255,0,0,255,95,173,90,170,90,170,90,170,93,175,255,0,
0,0,255,0,0,0,0,0,0,0,0,0,85,255,0,0,
0,255,124,236,84,212,84,212,84,212,108,253,255,0,0,255,
255,64,64,255,85,170,85,170,85,170,85,170,85,170,255,64,
64,64,255,126,182,106,170,106,170,106,170,118,191,255,64,64,
64,255,85,170,85,170,85,170,85,170,85,170,255,64,64,255,
255,0,0,255,85,170,85,170,85,170,85,170,85,170,255,0,
0,0,255,85,170,85,170,85,170,85,170,85,170,255,0,0,
0,255,85,170,85,170,85,170,85,170,85,170,255,0,0,255,
255,0,0,255,85,170,85,170,85,170,85,170,85,170,255,0,
0,0,255,85,170,85,170,85,170,85,170,85,170,255,0,0,
0,255,85,170,85,170,85,170,85,170,85,170,255,0,0,255,
63,64,128,143,141,138,141,138,141,138,141,138,141,138,143,128,
128,128,143,141,138,141,138,141,138,141,138,141,138,143,128,128,
128,143,141,138,141,138,141,138,141,138,141,138,143,128,64,63
};

flash unsigned char str_3[]={   
0,0,0,0,0,0,0,0,128,192,96,160,112,184,216,172,
86,174,86,174,86,171,87,251,247,171,87,170,86,174,84,164,
220,168,88,144,112,224,192,128,0,0,0,0,0,0,0,0,
0,0,192,224,112,188,214,235,213,170,85,170,85,171,87,171,
85,170,85,170,85,170,85,255,255,170,85,170,85,170,85,171,
87,171,85,170,85,170,213,235,213,175,78,184,224,128,0,0,
224,254,87,170,213,234,213,171,85,170,85,170,85,170,85,170,
85,170,85,170,85,170,85,255,255,170,213,170,213,170,213,170,
213,170,213,170,213,170,213,171,213,170,213,170,85,47,252,224,
7,63,213,170,87,171,87,170,85,170,85,170,85,170,85,170,
85,170,85,170,85,170,85,171,85,171,85,171,85,171,85,171,
85,171,85,171,85,171,85,171,85,171,85,171,85,234,127,15,
0,0,3,14,25,54,119,207,87,170,85,170,85,234,213,234,
85,170,85,170,85,170,85,170,85,170,85,170,85,170,85,170,
213,170,85,170,85,170,87,175,215,234,101,58,7,3,0,0,
0,0,0,0,0,0,0,0,1,3,6,13,13,27,21,59,
53,106,117,234,213,234,223,238,223,238,213,234,213,106,85,107,
103,59,21,26,13,6,7,3,1,0,0,0,0,0,0,0
};

flash unsigned char str_4[]={   
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,128,192,224,224,112,112,56,184,56,
184,56,120,48,48,60,126,246,230,198,126,124,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,128,224,240,120,158,15,71,3,5,32,1,4,0,2,0,
0,0,0,0,0,128,32,8,33,151,47,254,252,0,0,0,
0,0,0,128,192,192,224,224,224,224,192,192,240,248,184,190,
15,87,3,18,0,2,0,0,0,0,0,0,0,0,128,32,
64,8,144,34,16,168,82,169,84,202,253,127,15,0,0,0,
0,0,6,31,127,253,235,213,170,85,171,213,235,245,251,247,
251,255,255,94,174,92,188,120,240,224,232,192,170,0,146,164,
65,170,80,170,213,234,117,62,15,3,1,0,0,0,0,0,
0,0,0,0,0,1,3,7,15,31,60,59,119,239,239,223,
175,215,43,85,170,85,170,85,170,85,171,85,171,87,175,94,
253,250,255,207,3,1,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,
3,7,7,15,14,31,30,61,58,125,122,117,106,245,234,245,
234,245,235,127,63,28,0,0,0,0,0,0,0,0,0,0
};

flash unsigned char str_5[]={    
254,255,255,127,79,15,159,71,71,159,15,79,127,255,255,254,
127,255,255,254,242,240,249,226,226,249,240,242,254,255,255,127
};

flash unsigned char str_6[]={   
254,1,25,25,1,255,1,129,129,1,255,1,13,13,1,254,
127,128,128,128,128,255,128,129,129,128,255,128,128,128,128,127
};

flash unsigned char str_7[]={   
30,227,123,125,254,254,254,0,0,126,126,124,121,115,199,30,
112,231,206,158,191,63,127,78,78,126,62,190,190,158,231,112
};

flash unsigned char str_8[]={  
126,127,127,127,63,159,143,231,243,241,253,253,189,104,1,250,
126,252,241,226,225,192,148,169,19,42,83,5,58,252,255,127
};

flash unsigned char str_9[]={  
2,6,10,18,34,66,130,194,98,50,26,14,6,2
};

flash unsigned char str_10[]={  
24,24,52,122,255,90,153
};

flash unsigned char str_11[]={  
255};

flash unsigned char str_12[]={  
129, 129, 255};

flash unsigned char str_13[]={  
129, 129, 129,129, 129, 129,129, 129, 129,129, 129, 129,129, 129, 129,129, 129, 129,129, 129, 129};

flash unsigned char str_14[]={  
255, 255, 255, 255, 255, 255, 255, 255,255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,255, 255, 255, 255, 255, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,255, 255, 255, 255, 255, 255, 255, 255    };

flash unsigned char str_15[]={  
255,189,153  };

flash unsigned char str_16[]={  
28,34,93,85,93,34,28,0,8,28,42,8,8,8,8,8  };

flash unsigned char str_17[]={  
8,8,42,28,8 };

flash unsigned char str_18[]={  
8,28,42,8,8 };

flash unsigned char str_19[]={  
255 };

flash unsigned char *tabstr[]={str_1, str_2, str_3, str_4, str_5, str_6, str_7, str_8, str_9,
str_10,  str_11,  str_12,  str_13, str_14, str_15, str_16, str_17,str_18, str_19};  

void data_port (unsigned char data) {	
PORTA=data;
}
void strob(void) {			
delay_us(1);
PORTC |=(1<<2);;;					
delay_us(1);				
PORTC &=~(1<<2);;;				    
delay_us(9);				
}
void Display_ON (void) {	
PORTD &=~(1<<6);;		;					
PORTD &=~(1<<7);;			;						
data_port(0b00111111);		
strob();					
}
void Display_OFF (void) {		
PORTD &=~(1<<6);;		;					
PORTD &=~(1<<7);;			;						
data_port(0b00111110);		
strob();					
}
void LCD_init(void) {			
PORTC &=~(1<<2);;;
PORTC &=~(1<<5);;;					
delay_us(2);				
PORTC |=(1<<5);; ;					
delay_us(11);				
PORTD &=~(1<<6);;		;
PORTD &=~(1<<7);;			;

PORTC |=(1<<3);;		;
PORTC &=~(1<<4);;		;
data_port(0b11000000);			
strob();
data_port(0b10111000);                        
strob();
data_port(0b01000000);			
strob();
Display_ON();			

PORTC &=~(1<<3);;		;
PORTC |=(1<<4);;		;
data_port(0b11000000);			
strob();
data_port(0b10111000);                        
strob();
data_port(0b01000000);			
strob();
Display_ON();			
}

void LCD_clear(void) {     
unsigned char i;
unsigned char m;
PORTC |=(1<<3);;		;
PORTC |=(1<<4);;		;
for (m=0; m<=7; m++){ 
PORTD &=~(1<<6);;		;
PORTD &=~(1<<7);;			;
data_port(0b10111000+m);                        
strob();
data_port(0b01000000+m);			
strob();
PORTD |=(1<<6);;			;

for (i=0; i<=64; i++){
data_port(0);
strob();
} 
}
}

void page_kolonka_SL_massiv_nmass_inv_peren (unsigned char page, unsigned char kolonka,  unsigned char SL, unsigned char massiv, unsigned int nmass, unsigned char invert, unsigned char perenos) {  
unsigned char CS1,CS2;
flash unsigned char*stolb=0;
unsigned int i=0;				
unsigned int x=0;				
unsigned char temp_kolonka;		
unsigned char temp_page;		

if (kolonka>=64) {CS1=0; CS2=1; kolonka-=64; }
else {CS1=1; CS2=0;}
temp_kolonka = kolonka;
temp_page = page;
PORTD &=~(1<<6);;		;
PORTD &=~(1<<7);;			;
if (CS1==1){PORTC |=(1<<3);;		;}			
else { PORTC &=~(1<<3);;		;};
if (CS2==1) {PORTC |=(1<<4);;		;}			
else { PORTC &=~(1<<4);;		;};
data_port(0b11000000+SL);		
strob();
data_port(0b10111000+temp_page);	
strob();
data_port(0b01000000+temp_kolonka);  
strob();
stolb=tabstr[massiv];                                
PORTD |=(1<<6);;			;
PORTD &=~(1<<7);;			;
for (i=0; i<=nmass-1; i++){     
if (invert==0) {data_port(*stolb); }
if (invert==1) {data_port(~*stolb); }
strob();
stolb++;
x++;
if ((perenos+kolonka)>63) {           
if ((x+temp_kolonka)==64){    
PORTD &=~(1<<6);;		;                                               
PORTC &=~(1<<3);;		;
PORTC |=(1<<4);;		;
data_port(0b10111000+temp_page);	
strob();
data_port(0b01000000);  
strob();
PORTD |=(1<<6);;			;                                 
} 
if ((x+temp_kolonka)==(perenos+kolonka)) {   
PORTC &=~(1<<4);;		;                                                              
PORTC |=(1<<3);;		;
x=0;
temp_kolonka=kolonka;
PORTD &=~(1<<6);;		;                                               
temp_page++;                                           
data_port(0b10111000+temp_page);        
strob();                                                     
data_port(0b01000000+temp_kolonka);  
strob();
PORTD |=(1<<6);;			;}        
} 

else {     
if ((x+temp_kolonka)==(perenos+kolonka)) {   
x=0;
temp_kolonka=kolonka;
PORTD &=~(1<<6);;		;                                               
temp_page++;                                           
data_port(0b10111000+temp_page);        
strob();                                                     
data_port(0b01000000+temp_kolonka);  
strob();
PORTD |=(1<<6);;			;}        
}  
};   
}

void putstr (unsigned char string[],unsigned char CS1, unsigned char CS2, unsigned char page, unsigned char kolonka, unsigned char SL,unsigned char invert) {
unsigned char a;			
unsigned char b;			
unsigned char n;			
unsigned char i;				
unsigned char z;			
unsigned char t_sym=0;		
unsigned char stroka;			
unsigned char tek_kol=0;		
unsigned char tek_page=0;		
unsigned char crystall=0;		
PORTD &=~(1<<6);;		;
PORTD &=~(1<<7);;			;
if (CS1==1){				
PORTC |=(1<<3);;		;
crystall=1;}
else { PORTC &=~(1<<3);;		;};
if (CS2==1) {				
PORTC |=(1<<4);;		;
crystall=2;
}
else { PORTC &=~(1<<4);;		;};
data_port(0b11000000+SL);		
strob();
data_port(0b10111000+page);	
strob();
data_port(0b01000000+kolonka);	
strob();
n = strlen(string);
PORTD |=(1<<6);;			;
tek_page=page;
tek_kol=kolonka;		

for (i=0; i<n; i++) {	

if ((string[t_sym] >=47)&&(string[t_sym]<=95)) {	a=0;b=4; stroka= (string[t_sym]-32); goto m1; }
if (string[t_sym] ==58)  {a=2; b=2;  stroka=26;goto m1;  }

if ((string[t_sym] >=34)&&(string[t_sym]<=38)) {	 a=0; b=4; stroka= (string[t_sym]-32);goto m1;  }

if ((string[t_sym] >=39)&&(string[t_sym]<=41)) {	 a=1; b=3; stroka= (string[t_sym]-32);goto m1;  }

if ((string[t_sym] >=42)&&(string[t_sym]<=45)) {	 a=0; b=4; stroka= (string[t_sym]-32);goto m1;  }

if (string[t_sym] ==46)  {a=2; b=2;  stroka=14; goto m1; }       
if ((string[t_sym] >=32)&&(string[t_sym]<=33)) {a=2; b=2; stroka= (string[t_sym]-32);goto m1;  }         
if (string[t_sym] ==184) {a=0; b=4; stroka=95;goto m1;  }        
if (string[t_sym] ==168) { a=0; b=4; stroka=94;goto m1;   }	     
if ((string[t_sym] >=97)&&(string[t_sym]<=126)) {a=0; b=4; stroka= (string[t_sym]-33);goto m1;  } 
if ((string[t_sym] >=192)&&(string[t_sym]<=255)) {a=0; b=4; stroka= (string[t_sym]-96);goto m1; }  

m1:
for (z=a; z<=b; z++) {
tek_kol++;
if(tek_kol>=65) {	
tek_kol=0;								
PORTD &=~(1<<6);;		;								
PORTD &=~(1<<7);;			;
if (crystall==1) {	
PORTC &=~(1<<3);;		;								
PORTC |=(1<<4);;		;								
crystall=2;								
data_port(0b10111000+tek_page);				
strob();
data_port(0b01000000);						
strob();
PORTD |=(1<<6);;			;
}
}
if (invert==1) {
data_port(~symbols [stroka] [z] );
strob();  }
else {
data_port(symbols [stroka] [z]) ;
strob(); };
}  
if (invert==1) {      
data_port(255) ;
strob();
}
else {                    
data_port(0) ;
strob();
};
tek_kol++;

t_sym++;               
}
}   

#pragma used+
void i2_start(void);
void i2_stop (void);
unsigned char i2_write (unsigned char bw);
void tda7313_write(unsigned char command);

#pragma used-

#pragma library i2c_and_TDA7313.lib

void  menu_5_6_7_8_29_65 (unsigned char men5, unsigned char men6,unsigned char men7, unsigned char men8, unsigned char men29, unsigned char men65) {  
LCD_clear();

switch ( tek_vhod) {
case 1: loudness=loudness1;   break;
case 2: loudness=loudness2;   break;
case 3: loudness=loudness3;   break;
};

putstr(txt4,1,0,0,0,0,men5);      
volume_ogr_displ= volume_ogr*125;
sprintf(buffer, "-%i.%02i",volume_ogr_displ/100, volume_ogr_displ%100);  putstr(buffer,0,1,0,27,0,men5);

putstr(txt5,1,0,1,0,0,men6);                
volume_on_max_displ= volume_on_max*125;
sprintf(buffer, "-%i.%02i",volume_on_max_displ/100, volume_on_max_displ%100);
putstr(buffer,0,1,1,28,0,men6);

putstr(txt6,1,0,2,0,0,men7);              
att_displ=att*125;
sprintf(buffer, "-%i.%02i",att_displ/100, att_displ%100);
putstr(buffer,0,1,2,28,0,men7);
putstr(txt7,1,0,3,0,0,men8);              
loud_displ= loudness*375;
if (loudness>=1) {sprintf(buffer, "+%i.%02i",loud_displ/100, loud_displ%100);
putstr(buffer,0,1,3,28,0,men8);}
else {sprintf(buffer, "%i",loud_displ);
putstr(buffer,0,1,3,58,0,men8);}

putstr(txt18,1,0,4,0,0,men29);              
sprintf(buf, "%d",valcoder_sens);
putstr(buf,0,1,4,54,0,men29);

putstr(txt38,1,0,5,0,0,men65);              
page_kolonka_SL_massiv_nmass_inv_peren (5,123,0,16,5,0,5);

putstr(txt1,1,0,7,37,0,0);		

}

void  menu_9_10(unsigned char men9, unsigned char men10) {
unsigned char a;  

switch ( tek_vhod) {
case 1: bass=bass1; treble= treble1;   break;
case 2: bass=bass2; treble= treble2;     break;
case 3: bass=bass3; treble= treble3;    break;
};

a=14-treble;    
treble_disp= treble-a;  
a=14-bass;    
bass_disp= bass-a;  
LCD_clear();

putstr(txt9,1,0,0,0,0,men9);  
if (treble<=7)  { sprintf(buffer, "%d ",treble_disp);  }
if (treble>7)  { sprintf(buffer, "+%d ",treble_disp);  }
putstr(buffer,0,1,0,20,0,men9);

putstr(txt10,1,0,2,0,0,men10);         
if (bass<=7)  { sprintf(buffer, "%d ",bass_disp);  }
if (bass>7)  { sprintf(buffer, "+%d ",bass_disp);  }
putstr(buffer,0,1,2,20,0,men10);

putstr(txt2,1,0,7,35,0,0);                  
}
void  menu_11__16(unsigned char men11,  unsigned char men12, unsigned char men13, unsigned char men14, unsigned char men15, unsigned char men16) {
LCD_clear();
putstr(txt11,1,0,0,0,0,0);  putstr(txt12,1,0,2,0,0,0);                  
rtc_get_date(&date,&mounth,&year);                                       
rtc_get_time(&h,&m,&s);                                                           
sprintf(buf, "%02d",date); putstr(buf,0,1,0,15,0,men11);
putstr(txt17,0,1,0,28,0,0);
sprintf(buf, "%02d",mounth); putstr(buf,0,1,0,31,0,men12);
putstr(txt17,0,1,0,44,0,0);
sprintf(buf, "%02d",year); putstr(buf,0,1,0,47,0,men13);
sprintf(buf, "%02d",h);putstr(buf,0,1,2,15,0,men14);
putstr(txt17,0,1,2,28,0,0);
sprintf(buf, "%02d",m);putstr(buf,0,1,2,31,0,men15);
putstr(txt17,0,1,2,44,0,0);
sprintf(buf, "%02d",s);putstr(buf,0,1,2,47,0,men16);
putstr(txt8,1,0,7,40,0,0);                                                              
}
void menu_17_18(unsigned char men17, unsigned char men18) {
LCD_clear();
putstr(txt13,1,0,0,0,0,men17);              
putstr(txt14,1,0,2,0,0,men18);             
putstr(txt15,0,1,0,30,0,0);          
putstr(txt15,0,1,2,30,0,0);          
putstr(txt3,1,0,7,40,0,0);
}
void menu_19_20_21(unsigned char men19_20_21) {
unsigned char a=0;
unsigned char b=0;
unsigned char c=0;
unsigned char d=0;
LCD_clear();
switch (men19_20_21) {
case 19:  a=1; b=0; c=1; d=0;  break;
case 20:  a=1; b=0; c=0; d=1;  break;
case 21:  a=0; b=1; c=0;  d=0; break;
};
putstr(txt13,1,0,0,0,0,a);             
putstr(txt14,1,0,2,0,0,b);             
sprintf(buf, "%02d",hour_on);    
putstr(buf,0,1,0,30,0,c);
putstr(txt16,0,1,0,42,0,0);
sprintf(buf, "%02d",min_on);    
putstr(buf,0,1,0,48,0,d);
putstr(txt15,0,1,2,30,0,0);          
putstr(txt3,1,0,7,40,0,0);

}

void menu_22_23_27_28(unsigned char men_x) {
unsigned char x1=0, x2=0, x3=0, x4=0, x5=0, x6=0;
LCD_clear();
switch (men_x) {
case 22:  x1=0;  x2=1;  x3=0;   x4=0;   x5=1;   x6=0;  break;
case 23:  x1=0;  x2=1;  x3=0;   x4=0;   x5=0;   x6=1;  break;
case 27:  x1=1;  x2=0;  x3=1;   x4=0;   x5=0;   x6=0;  break;
case 28:  x1=1;  x2=0;  x3=0;   x4=1;   x5=0;   x6=0;  break;
};
putstr(txt13,1,0,0,0,0,x1);              
putstr(txt14,1,0,2,0,0,x2);             
sprintf(buf, "%02d",hour_on);    
putstr(buf,0,1,0,30,0,x3);
putstr(txt16,0,1,0,42,0,0);
sprintf(buf, "%02d",min_on);    
putstr(buf,0,1,0,48,0,x4);
sprintf(buf, "%02d",hour_off);    
putstr(buf,0,1,2,30,0,x5);
putstr(txt16,0,1,2,42,0,0);
sprintf(buf, "%02d",min_off);    
putstr(buf,0,1,2,48,0,x6);
putstr(txt3,1,0,7,40,0,0);
}
void menu_24_25_26(unsigned char men_x2) {
unsigned char x1=0, x2=0, x3=0, x4=0;
LCD_clear();
switch (men_x2) {
case 24:  x1=0;  x2=1;  x3=1;   x4=0;  break;
case 25:  x1=0;  x2=1;  x3=0;   x4=1;  break;
case 26:  x1=1;  x2=0;  x3=0;   x4=0;  break;
};
putstr(txt13,1,0,0,0,0,x1);              
putstr(txt14,1,0,2,0,0,x2);             
putstr(txt15,0,1,0,30,0,0);          
sprintf(buf, "%02d",hour_off);    
putstr(buf,0,1,2,30,0,x3);
putstr(txt16,0,1,2,42,0,0);
sprintf(buf, "%02d",min_off);    
putstr(buf,0,1,2,48,0,x4);
putstr(txt3,1,0,7,40,0,0);
}

void menu_0 (void)  {
unsigned char a;
unsigned char b=1;
unsigned int c;
unsigned char t;
unsigned char r;

if (Refr4==1) {  LCD_clear(); }           

if ((Refr1==1)||(Refr4==1)) {               
sprintf(buffer, "%02d:%02d:%02d", hour, min,sec);
putstr(buffer,0,1,0,15,0,0);
Refr1=0;  
}

if ((Refr2==1)||(Refr4==1)) {   
page_kolonka_SL_massiv_nmass_inv_peren(7,121,0,9,7,0,7);		
volume_displ= volume*125;								
sprintf(buffer, "-%i.%02i",volume_displ/100, volume_displ%100);
putstr(buffer,0,1,7,25,0,0);
page_kolonka_SL_massiv_nmass_inv_peren(7,0,0,10,1,0,1);			
for (a=0;a<=3;a++) {
page_kolonka_SL_massiv_nmass_inv_peren(7,b,0,12,21,0,21);		
b+=21;
};
b=1;
page_kolonka_SL_massiv_nmass_inv_peren(7,85,0,11,3,0,3);		
c=64-volume;										
if (c<=20) {c*=2;}
else {c+=22;};
page_kolonka_SL_massiv_nmass_inv_peren(7,1,0,13,c,0,c);

if (volume_ogr>=6) {		
c=64-volume_ogr;		
if (c<=20) {c*=2;}
else {c+=22;};
c++;					
page_kolonka_SL_massiv_nmass_inv_peren(7,c,0,14,3,0,4); }	

putstr(txt22,1,0,6,0,0,0);		
Refr2=0;					
};				

if (Refr4==1) {		

switch (tek_vhod) {
case 1 : putstr(txt19,1,0,0,18,0,0);   break;		
case 2 : putstr(txt20,1,0,0,18,0,0);   break;
case 3 : putstr(txt21,1,0,0,18,0,0);   break;
};
page_kolonka_SL_massiv_nmass_inv_peren(0,0,0,15,16,0,16);	

switch (tek_vhod) {
case 1 :  bass=bass1; treble=treble1; loudness=loudness1;   break;         
case 2 :  bass=bass2; treble=treble2; loudness=loudness2;   break;
case 3 :  bass=bass3; treble=treble3; loudness=loudness3;   break;
};

a=14-treble;    
treble_disp= treble-a;  
a=14-bass;    
bass_disp= bass-a;  

if (treble<=7)  { sprintf(buffer, " %d ",treble_disp);  }
if (treble>7)  { sprintf(buffer, " +%d ",treble_disp);  }
putstr(buffer,1,0,1,0,0,0);

if (bass<=7)  { sprintf(buffer, " %d ",bass_disp);  }
if (bass>7)  { sprintf(buffer, " +%d ",bass_disp);  }
putstr(buffer,1,0,2,0,0,0);
Refr3=0;
}; 

t=0;   
if (att_on==1) {                       
t++;
putstr(txt23,0,1,t,44,0,mig_att);};      

if (amp_off_act==1) {                     
t++;
putstr(txt24,1,0,t,50,0,0);
sprintf(buffer, "%02d:%02d",hour_off, min_off );
putstr(buffer,0,1,t,33,0,0);
};

if (amp_on_act==1) {                          
t++;
putstr(txt25,1,0,t,50,0,0);
sprintf(buffer, "%02d:%02d",hour_on, min_on );
putstr(buffer,0,1,t,33,0,0);
};

r=3;      

if (t==3) {r=4;}

loud_displ= loudness*375;                                                                                            
if (loudness>=1) {sprintf(buffer, " +%i.%02i ",loud_displ/100, loud_displ%100);
putstr(buffer,1,0,r,0,0,0);}
else {sprintf(buffer, " %i ",loud_displ);
putstr(buffer,1,0,r,0,0,0);}

Refr4=0;
}

void menu_30 (void)  {           

if (Refr30==1) {                  
LCD_clear();
}
sprintf(buffer, " : %i",rem_command );
putstr(buffer,1,0,0,0,0,0);
sprintf(buffer, " : %i",adr);
putstr(buffer,1,0,2,0,0,0);
Refr30=0;
}  

void menu_31__38 (unsigned char menu) {
unsigned int address;		
unsigned int res;		
unsigned char p;		

unsigned char inv_0=0;		
unsigned char inv_1=0;
unsigned char inv_2=0;
unsigned char inv_3=0;
unsigned char inv_4=0;
unsigned char inv_5=0;
unsigned char inv_6=0;
unsigned char inv_7=0;

menu_temp=menu;		

switch (menu) {
case 31: inv_0=1; break;
case 32: inv_1=1; break;
case 33: inv_2=1; break;
case 34: inv_3=1; break;
case 35: inv_4=1; break;
case 36: inv_5=1; break;
case 37: inv_6=1; break;
case 38: inv_7=1; break;
};
LCD_clear();

putstr(txt26,1,0,0,0,0,0);
sprintf(buffer, " %u",stage_temp );
putstr(buffer,0,1,0,14,0, inv_0);

for (p=1;p<=7;p++) {page_kolonka_SL_massiv_nmass_inv_peren (p,123,0,16,5,0,5);};

address=(11+stage);					
res = read_from_AD7142_spi (address);		
sprintf(buffer, "(%03x)  ADC_RES=%u ",address,res);
putstr(buffer,1,0,1,0,0, inv_1);				

address=224+(36*stage);				
res = read_from_AD7142_spi (address);		
if (menu==33) { address_temp=address; res_temp=res;}
sprintf(buffer, "(%03x)  STA_RES=%u ",address, res);
putstr(buffer,1,0,2,0,0, inv_2);				

address=241+(36*stage);
res = read_from_AD7142_spi (address);
if (menu==34) { address_temp=address; res_temp=res;}
sprintf(buffer, "(%03x)  AMBIENT=%u ",address, res);
putstr(buffer,1,0,3,0,0, inv_3);				

address=249+(36*stage);
res = read_from_AD7142_spi (address);
if (menu==35) { address_temp=address; res_temp=res;}
sprintf(buffer, "(%03x)  MAX_AVG=%u ",address, res);
putstr(buffer,1,0,4,0,0, inv_4);				

address=250+(36*stage);
res = read_from_AD7142_spi (address);
if (menu==36) { address_temp=address; res_temp=res;}
sprintf(buffer, "(%03x)  HI_TRES=%u ",address, res);
putstr(buffer,1,0,5,0,0, inv_5);				

address=256+(36*stage);
res = read_from_AD7142_spi (address);
if (menu==37) { address_temp=address; res_temp=res;}
sprintf(buffer, "(%03x)  MIN_AVG=%u ",address, res);
putstr(buffer,1,0,6,0,0, inv_6);				

address=257+(36*stage);
res = read_from_AD7142_spi (address);
if (menu==38) { address_temp=address; res_temp=res;}
sprintf(buffer, "(%03x)  LO_TRES=%u ",address, res);
putstr(buffer,1,0,7,0,0, inv_7);				

}

void menu_39__45 (unsigned char menu)  {	
unsigned int a;	
unsigned char b;	

unsigned int c;	
unsigned char d;	
unsigned char st;	

unsigned int address;	
unsigned int res;		
b=2;
LCD_clear();

page_kolonka_SL_massiv_nmass_inv_peren (0,0,0,17,5,0,5);	

switch (menu) {
case 39:  a=11; c=1; putstr(txt27,1,0,0,10,0,0);	break;
case 40:  a=224; c=36; putstr(txt28,1,0,0,10,0,0);	break;
case 41:  a=241; c=36; putstr(txt29,1,0,0,10,0,0);	break;
case 42:  a=249; c=36; putstr(txt30,1,0,0,10,0,0);	break;
case 43:  a=250; c=36; putstr(txt31,1,0,0,8,0,0);	break;
case 44:  a=256; c=36; putstr(txt32,1,0,0,8,0,0);	break;
case 45:  a=257; c=36; putstr(txt33,1,0,0,8,0,0);	break;
};

st=0;

b=2;				
for (d=0;d<=5;d++) {		
address=(a);			
res = read_from_AD7142_spi (address);	
sprintf(buffer, "%u:%u",st,res);	
putstr(buffer,1,0,b,0,0,0);		
a+=c;				
st++;				
b++;				
};
b=2;				

for (d=0;d<=5;d++) {		
address=(a);			
res = read_from_AD7142_spi (address);	
sprintf(buffer, "%u:%u",st,res);	
putstr(buffer,0,1,b,0,0,0);		
a+=c;				
st++;				
b++;				
};
}	

void menu_46__54(unsigned char menu) {	
unsigned char d;		
unsigned int address;	
unsigned int res;		
unsigned char b;		
unsigned char inv1;		

if (menu==46) {inv1=1;}
else {inv1=0;};

LCD_clear();

sprintf(buffer, " ");	
putstr(buffer,1,0,0,0,0,0);
sprintf(buffer, "%u",stage_temp);	
putstr(buffer,0,1,0,48,0,inv1);

sprintf(buffer, ".  %u .",(stage+33));
putstr(buffer,1,0,1,0,0,0);
sprintf(buffer, " 2  AD7142");
putstr(buffer,1,0,2,0,0,0);

address=128+(stage*8);				

b=4;								
for (d=0;d<=3;d++) {					
if ((menu-b)==43) {inv1=1;}				
else {inv1=0;};
res = read_from_AD7142_spi (address);		
if (inv1==1) {address_temp=address;  res_temp=res; menu_temp=menu;}

sprintf(buffer, "(%02x):%u",address,res);	
putstr(buffer,1,0,b,0,0,inv1);				
address++;							
b++;								
};

b=4;								
for (d=0;d<=3;d++) {					

if ((menu-b)==47) {inv1=1;}
else {inv1=0;};

res = read_from_AD7142_spi (address);		
if (inv1==1) {address_temp=address;  res_temp=res; menu_temp=menu;}

sprintf(buffer, "(%02x):%u",address,res);	
putstr(buffer,0,1,b,0,0,inv1);				
address++;							
b++;								
};

}

void menu_55__62(unsigned char menu) {		
unsigned char d;		
unsigned char b;		
unsigned int res;		
unsigned char inv;		
unsigned int address;		
LCD_clear();
putstr(txt34,1,0,0,6,0,0);				

address=0;
b=4;								
for (d=0;d<=3;d++) {					

if ((menu-b)==51) {inv=1;}
else {inv=0;};
res = read_from_AD7142_spi (address);		
if (inv==1) {address_temp=address;  res_temp=res; menu_temp=menu;}

sprintf(buffer, "(%u):",address);	
putstr(buffer,1,0,b,0,0,0);		

sprintf(buffer, "%u",res);		
putstr(buffer,1,0,b,20,0,inv);	
address++;			
b++;				
};

b=4;				
for (d=0;d<=3;d++) {		
if ((menu-b)==55) {inv=1;}
else {inv=0;};
res = read_from_AD7142_spi (address);		
if (inv==1) {address_temp=address;  res_temp=res; menu_temp=menu;}
sprintf(buffer, "(%u):",address);			
putstr(buffer,0,1,b,0,0,0);				
sprintf(buffer, "%u",res);				
putstr(buffer,0,1,b,20,0,inv);				
address++;							
b++;								
};
};  

void menu_63__64 (unsigned char men) {
unsigned char inv;		

LCD_clear();
putstr(txt35,0,1,0,0,0,0);
putstr(txt36,1,0,0,0,0,0);
putstr(txt37,1,0,4,0,0,0);

sprintf(buffer, "HEX=%x",address_temp);
putstr(buffer,1,0,1,0,0,0);
sprintf(buffer, "DEC=%u",address_temp);
putstr(buffer,1,0,2,0,0,0);

sprintf(buffer, "HEX=%x",res_temp);
putstr(buffer,1,0,5,0,0,0);
sprintf(buffer, "DEC=%u",res_temp);
putstr(buffer,1,0,6,0,0,0);

if (men==63) {inv=1;} else {inv=0;};

sprintf(buffer, "%x",address_temp); 	
putstr(buffer,0,1,1,10,0,0);
sprintf(buffer, "%u",address_temp); 	
putstr(buffer,0,1,2,10,0,inv);

if (men==64) {inv=1;} else {inv=0;};
sprintf(buffer, "%x",res_temp);	
putstr(buffer,0,1,5,10,0,0);
sprintf(buffer, "%u",res_temp);	
putstr(buffer,0,1,6,10,0,inv);
}

void menu_66__69 (unsigned char menu) {
unsigned char inv1;		
unsigned char inv2;		
unsigned char inv3;		
unsigned char inv4;		
unsigned char p;

switch (menu) {
case 66:	inv1=1; inv2=0;inv3=0; inv4=0;  menu_temp=menu;break;
case 67:	inv2=1; inv1=0;inv3=0; inv4=0;  menu_temp=menu;break;
case 68:	inv3=1; inv1=0;inv2=0; inv4=0;  menu_temp=menu;break;
case 69:	inv4=1; inv1=0;inv2=0; inv3=0;  menu_temp=menu;break;
};

LCD_clear();
for (p=2;p<=5;p++) {page_kolonka_SL_massiv_nmass_inv_peren (p,123,0,16,5,0,5);}; 

putstr(txt39,1,0,0,23,0,0);
putstr(txt40,1,0,2,0,0,inv1);
putstr(txt41,1,0,3,0,0,inv2);
putstr(txt42,1,0,4,0,0,inv3);
putstr(txt43,1,0,5,0,0,inv4);
}

void display_menu (unsigned char num_of_menu) { 
switch ( num_of_menu) { 
case 0: menu_0 ();   break;        
case 1: LCD_clear();
page_kolonka_SL_massiv_nmass_inv_peren(1,0,0,0,288,0,48);
page_kolonka_SL_massiv_nmass_inv_peren(5,60,0,4,32,0,16);
page_kolonka_SL_massiv_nmass_inv_peren(5,77,0,5,32,0,16);
page_kolonka_SL_massiv_nmass_inv_peren(5,94,0,6,32,0,16);
page_kolonka_SL_massiv_nmass_inv_peren(5,111,0,7,32,0,16);
page_kolonka_SL_massiv_nmass_inv_peren(4,61,0,8,14,0,14); 
putstr(txt1,1,0,2,60,0,0);   break;

case 2:
LCD_clear();
page_kolonka_SL_massiv_nmass_inv_peren(1,0,0,1,288,0,48);  
page_kolonka_SL_massiv_nmass_inv_peren(5,60,0,4,32,0,16);
page_kolonka_SL_massiv_nmass_inv_peren(5,77,0,5,32,0,16);
page_kolonka_SL_massiv_nmass_inv_peren(5,94,0,6,32,0,16);
page_kolonka_SL_massiv_nmass_inv_peren(5,111,0,7,32,0,16);
page_kolonka_SL_massiv_nmass_inv_peren(4,78,0,8,14,0,14);   
putstr(txt2,1,0,2,60,0,0);   break;

case 3:
LCD_clear();
page_kolonka_SL_massiv_nmass_inv_peren(1,0,0,2,288,0,48);  
page_kolonka_SL_massiv_nmass_inv_peren(5,60,0,4,32,0,16);
page_kolonka_SL_massiv_nmass_inv_peren(5,77,0,5,32,0,16);
page_kolonka_SL_massiv_nmass_inv_peren(5,94,0,6,32,0,16);
page_kolonka_SL_massiv_nmass_inv_peren(5,111,0,7,32,0,16);
page_kolonka_SL_massiv_nmass_inv_peren(4,95,0,8,14,0,14);   
putstr(txt8,1,0,2,60,0,0);   break;

case 4:
LCD_clear();
page_kolonka_SL_massiv_nmass_inv_peren(1,0,0,3,288,0,48);  
page_kolonka_SL_massiv_nmass_inv_peren(5,60,0,4,32,0,16);
page_kolonka_SL_massiv_nmass_inv_peren(5,77,0,5,32,0,16);
page_kolonka_SL_massiv_nmass_inv_peren(5,94,0,6,32,0,16);
page_kolonka_SL_massiv_nmass_inv_peren(5,111,0,7,32,0,16);
page_kolonka_SL_massiv_nmass_inv_peren(4,112,0,8,14,0,14);   
putstr(txt3,1,0,2,60,0,0);   break;

case 5: menu_5_6_7_8_29_65(1,0,0,0,0,0);	break;
case 6: menu_5_6_7_8_29_65(0,1,0,0,0,0);	break;
case 7: menu_5_6_7_8_29_65(0,0,1,0,0,0);	break;
case 8: menu_5_6_7_8_29_65(0,0,0,1,0,0);	break;
case 9: menu_9_10(1,0);			break;
case 10: menu_9_10(0,1);			break;
case 11: menu_11__16(1,0,0,0,0,0);	break;
case 12: menu_11__16(0,1,0,0,0,0);	break;
case 13: menu_11__16(0,0,1,0,0,0);	break;
case 14: menu_11__16(0,0,0,1,0,0);	break;
case 15: menu_11__16(0,0,0,0,1,0);	break;
case 16: menu_11__16(0,0,0,0,0,1);	break;
case 17: menu_17_18(1,0);			break;
case 18: menu_17_18(0,1);			break;
case 19: menu_19_20_21(num_of_menu);		break;
case 20: menu_19_20_21(num_of_menu);		break;
case 21: menu_19_20_21(num_of_menu);		break;

case 22:menu_22_23_27_28( num_of_menu); 	break;
case 23:menu_22_23_27_28( num_of_menu); 	break;
case 27:menu_22_23_27_28( num_of_menu); 	break;
case 28:menu_22_23_27_28( num_of_menu); 	break;

case 29: menu_5_6_7_8_29_65(0,0,0,0,1,0);	break;
case 30: menu_30();				break;
case 63: menu_63__64(num_of_menu);	break;
case 64: menu_63__64(num_of_menu);	break;
case 65: menu_5_6_7_8_29_65(0,0,0,0,0,1);	break;

};

if ((num_of_menu>=24)&&(num_of_menu<=26)) {menu_24_25_26(num_of_menu);};
if ((num_of_menu>=31)&&(num_of_menu<=38)) {menu_31__38(num_of_menu);};
if ((num_of_menu>=39)&&(num_of_menu<=45)) {menu_39__45(num_of_menu);};
if ((num_of_menu>=46)&&(num_of_menu<=54)) {menu_46__54(num_of_menu);};
if ((num_of_menu>=55)&&(num_of_menu<=62)) {menu_55__62(num_of_menu);};
if ((num_of_menu>=66)&&(num_of_menu<=69)) {menu_66__69(num_of_menu);};

} 
unsigned char cnt_bit = 0;					
unsigned char code [14];					
unsigned char counter = 0;				
bit state =  0;							
bit error = 0;							

unsigned char startbit1 = 0;				
unsigned char startbit2 = 0;				
unsigned char toggle = 0;					
unsigned char address = 0;				

void RC5_decoder (void) {
counter = TCNT0;						
TCNT0 = 0x00;							
error = 1;								
if (cnt_bit == 0)							
{
TCCR0 = 0x04;							
code [cnt_bit] = !PIND.2;					
cnt_bit++;								
state = 1;								
}
else									
{
if ((counter>44						) && (counter<68))		
{
if (state)								
{
state = 0;								
error = 0;								
}
else									
{
state = 1;								
code[cnt_bit] = !PIND.2;					
cnt_bit++;								
error=0;								
};
};
if ((counter>80						) && (counter<136))			
{
code[cnt_bit] = !PIND.2;					
cnt_bit++;								
error = 0;								
};
if (error == 1)							
{
char i = 0;					
TCCR0 = 0x00;				
TCNT0 = 0x00;				
counter = 0;				
cnt_bit = 0;					
for (i=0; i<14; i++) code[i]=0;	
};
if (cnt_bit == 14)				
{
char i = 0;					
TCCR0 = 0x00;				
TCNT0 = 0x00;				
cnt_bit = 0;					

startbit1 = code[0];			
startbit2 = code[1];			
toggle = code[2];				

address = (code[3] << 4)|(code[4] << 3)|(code[5] << 2)|(code[6] << 1)|code[7];
rem_command = (code[8] << 5)|(code[9] << 4)|(code[10] << 3 )|(code[11] << 2)|(code[12] << 1)|code[13];      
command_tx=20;				
timer=0;					
for (i=0; i<14; i++) code[i]=0;	
};
};
}
void go_to_menu (unsigned char me) {               
tog_ch=toggle;
command_tx=10;
tek_menu=me;
if  (  tek_menu==0) {Refr4=1;}          
display_menu(tek_menu);
}

void menu_navi (void) { 
if ((command_tx==20)&&(tek_menu==0)&&(rem_command==48)&&(tog_ch!=toggle)) {  
tog_ch=toggle;                                                                                                  
tek_menu=1;
display_menu(tek_menu);
command_tx=10;              
}     

if ((command_tx==20)&&(tek_menu==1)&&(tog_ch!=toggle)) {  
switch ( rem_command) {    
case 16:   go_to_menu(2);   break;
case 17:      go_to_menu(4);  break;
case 59:     go_to_menu(5); break;
case 33:  go_to_menu(5);break;          
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(0); break;
};   
}

if ((command_tx==20)&&(tek_menu==2)&&(tog_ch!=toggle)) {  
switch ( rem_command) {    
case 16:  go_to_menu(3);   break;
case 17:    go_to_menu(1); break;
case 59:     go_to_menu(9);  break;
case 33: go_to_menu(9);  break;
case 48: go_to_menu(0); break;
case 34:  go_to_menu(0); break;
};   
}

if ((command_tx==20)&&(tek_menu==3)&&(tog_ch!=toggle)) {  
switch ( rem_command) {    
case 16:  go_to_menu(4); break;
case 17:    go_to_menu(2); break;
case 59:     go_to_menu(11); break;
case 33: go_to_menu(11); break;
case 48: go_to_menu(0); break;
case 34:  go_to_menu(0); break;
};   
} 

if ((command_tx==20)&&(tek_menu==4)&&(tog_ch!=toggle)) {  

if ((rem_command==59)&&(amp_on_act==0)&&(amp_off_act ==0)) { 
go_to_menu(17);}
if ((rem_command==59)&&(amp_on_act==1)&&(amp_off_act ==0)) { go_to_menu(19);}
if ((rem_command==59)&&(amp_on_act==0)&&(amp_off_act ==1)) { go_to_menu(24);}
if ((rem_command==59)&&(amp_on_act==1)&&(amp_off_act ==1)) { go_to_menu(27);}
if ((rem_command== 33)&&(amp_on_act==0)&&(amp_off_act ==0)) { go_to_menu(17);}
if ((rem_command== 33)&&(amp_on_act==1)&&(amp_off_act ==0)) { go_to_menu(19);}
if ((rem_command== 33)&&(amp_on_act==0)&&(amp_off_act ==1)) { go_to_menu(24);}
if ((rem_command== 33)&&(amp_on_act==1)&&(amp_off_act ==1)) { go_to_menu(27);}
switch ( rem_command) {    
case 16:  go_to_menu(1); break;
case 17:   go_to_menu(3); break;
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(0); break;
};   
} 

if ((command_tx==20)&&(tek_menu==5)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 33 :  go_to_menu(6);  break;
case 32 :      go_to_menu(1);  break;
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(1); break;
};   
} 

if ((command_tx==20)&&(tek_menu==6)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 33 :  go_to_menu(7);	break;
case 32 :       go_to_menu(5);	break;
case 48:  go_to_menu(0);		break;
case 34:  go_to_menu(1);	break;
};   
} 

if ((command_tx==20)&&(tek_menu==7)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 33 : go_to_menu(8);		break;
case 32 :       go_to_menu(6);	break;
case 48:  go_to_menu(0);		break;
case 34:  go_to_menu(1);	break;
};   
} 

if ((command_tx==20)&&(tek_menu==8)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :       go_to_menu(7);	break;
case 33 :  go_to_menu(29);	break;
case 48:  go_to_menu(0);		break;
case 34:  go_to_menu(1);	break;

};   
} 

if ((command_tx==20)&&(tek_menu==9)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 33 :  go_to_menu(10);  break;
case 32 :       go_to_menu(2);  break;
case 48: go_to_menu(0); break;
case 34:  go_to_menu(2); break;
};   
} 

if ((command_tx==20)&&(tek_menu==10)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :       go_to_menu(9);  break;
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(2); break;
};   
} 

if ((command_tx==20)&&(tek_menu==11)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :       go_to_menu(3); break;
case 33 : go_to_menu(14);  break;
case 16:    go_to_menu(12); break;
case 17:      go_to_menu(16); break;
case 48:   go_to_menu(0); break;
case 34:  go_to_menu(3); break;
};   
} 

if ((command_tx==20)&&(tek_menu==12)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 33 : go_to_menu(15); break;
case 16:    go_to_menu(13); break;
case 17:      go_to_menu(11); break;
case 48:   go_to_menu(0); break;
case 34:  go_to_menu(3); break;
};   
} 

if ((command_tx==20)&&(tek_menu==13)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 33 :  go_to_menu(16);  break;
case 16:   go_to_menu(14); break;
case 17:     go_to_menu(12); break;
case 48:   go_to_menu(0); break;
case 34:  go_to_menu(3); break;
};   
} 

if ((command_tx==20)&&(tek_menu==14)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :       go_to_menu(11); break;
case 16:   go_to_menu(15);break;
case 17:      go_to_menu(13); break;
case 48:   go_to_menu(0);break;
case 34:  go_to_menu(3); break;
};   
} 

if ((command_tx==20)&&(tek_menu==15)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  go_to_menu(12); break;
case 16:   go_to_menu(16); break;
case 17:     go_to_menu(14); break;
case 48:   go_to_menu(0); break;
case 34:  go_to_menu(3); break;
};   
} 

if ((command_tx==20)&&(tek_menu==16)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :	go_to_menu(13); break;
case 16:	go_to_menu(11); break;
case 17:	go_to_menu(15); break;
case 48:	go_to_menu(0); break;
case 34:  go_to_menu(3); break;
};   
} 

if ((command_tx==20)&&(tek_menu==17)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :           go_to_menu(4); break;
case 33 :      go_to_menu(18);  break;
case 16:        amp_on_act=1;  go_to_menu(19);    break;           
case 59:           amp_on_act=1; go_to_menu(19);   break;
case 48:        go_to_menu(0); break;
case 34:  go_to_menu(4); break;
};   
} 

if ((command_tx==20)&&(tek_menu==18)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  go_to_menu(17); break;
case 33 :  go_to_menu(17);  break;
case 16: amp_off_act=1;  go_to_menu(24); break;
case 59:  amp_off_act=1; go_to_menu(24); break;
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(4); break;
};   
} 

if ((command_tx==20)&&(tek_menu==19)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  go_to_menu(21); break;
case 33 :  go_to_menu(21);  break;
case 16: go_to_menu(20); break;
case 17:   go_to_menu(20); break;
case 59:   amp_on_act=0; go_to_menu(17); break;     
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(4); break;
};   
} 

if ((command_tx==20)&&(tek_menu==20)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  go_to_menu(21); break;
case 33 :  go_to_menu(21);  break;
case 16:   go_to_menu(19); break;
case 17:     go_to_menu(19); break;
case 59:   amp_on_act=0; go_to_menu(17); break;
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(4); break;
};   
} 

if ((command_tx==20)&&(tek_menu==21)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  go_to_menu(19); break;
case 33 :  go_to_menu(19);  break;
case 16: amp_off_act=1;  go_to_menu(22); break;
case 59:    amp_off_act=1;   go_to_menu(22); break;
case 17:     go_to_menu(20); break;
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(4); break;
};   
} 

if ((command_tx==20)&&(tek_menu==22)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  go_to_menu(27); break;
case 33 :  go_to_menu(27);  break;
case 16:   go_to_menu(23); break;
case 17:     go_to_menu(28); break;
case 59:    amp_off_act=0;   go_to_menu(21); break;
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(4); break;
};   
} 

if ((command_tx==20)&&(tek_menu==23)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  go_to_menu(28); break;
case 33 :  go_to_menu(28);  break;
case 16:   go_to_menu(27); break;
case 17:     go_to_menu(22); break;
case 59:    amp_off_act=0;   go_to_menu(21); break;
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(4); break;
};   
} 

if ((command_tx==20)&&(tek_menu==24)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  go_to_menu(26); break;
case 33 :  go_to_menu(26);  break;
case 16:   go_to_menu(25); break;
case 17:     go_to_menu(25); break;
case 59:    amp_off_act=0;   go_to_menu(18); break;
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(4); break;
};   
} 

if ((command_tx==20)&&(tek_menu==25)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  go_to_menu(26); break;
case 33 :  go_to_menu(26);  break;
case 16:   go_to_menu(24); break;
case 17:     go_to_menu(24); break;
case 59:    amp_off_act=0;   go_to_menu(18); break;
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(4); break;
};   
} 

if ((command_tx==20)&&(tek_menu==26)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  go_to_menu(24); break;
case 33 :  go_to_menu(24);  break;
case 16: amp_on_act=1;  go_to_menu(27); break;
case 17:   amp_on_act=1;   go_to_menu(28); break;
case 59:    amp_on_act=1;   go_to_menu(27); break;
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(4); break;
};   
} 

if ((command_tx==20)&&(tek_menu==27)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  go_to_menu(22); break;
case 33 :  go_to_menu(22);  break;
case 16:   go_to_menu(28); break;
case 17:     go_to_menu(23); break;
case 59:    amp_on_act=0;   go_to_menu(26); break;
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(4); break;
};   
} 

if ((command_tx==20)&&(tek_menu==28)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  go_to_menu(23); break;
case 33 :  go_to_menu(23);  break;
case 16:   go_to_menu(22); break;
case 17:     go_to_menu(27); break;
case 59:    amp_on_act=0;   go_to_menu(26); break;
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(4); break;
};   
} 

if ((command_tx==20)&&(tek_menu==29)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  go_to_menu(8); break;
case 33 :  go_to_menu(65);  break;
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(1); break;
};   
} 

if ((command_tx == 20)&&(tog_ch!=toggle)) {   

if ((rem_command == 55)&&(menu30==0)&&(tek_menu!=30)) {
menu30=1;			
tog_ch=toggle;		
command_tx=10;		
goto f;
} 

if ((rem_command != 52)&&(menu30==1)) { menu30=0;};	
if ((rem_command == 52)&&(menu30==1)) {
menu30=2;			
tog_ch=toggle;		
command_tx=10;		
goto f;
}  

if ((rem_command != 54)&&(menu30==2)) { menu30=0;};
if ((rem_command == 54)&&(menu30==2)) {
menu30 = 3;			
tog_ch = toggle;			
command_tx=10;			
goto f;
}

if ((rem_command != 50)&&(menu30==3)) { menu30=0;};

if ((rem_command == 50)&&(menu30==3)) {
tog_ch=toggle;
command_tx=10;

menu30=0;                    
Refr30=1;                    
go_to_menu(30);        
goto f;
} 

if ((tek_menu==30)&&(rem_command == 55)&&(menu30_2==0 )) {
tog_ch=toggle;
command_tx=10;
menu30_2=1;
goto f;
}

if ((rem_command != 55)&&(menu30_2==1 )) {menu30_2=0;};
if ((tek_menu==30)&&(rem_command == 55)&&(menu30_2==1 )) {
tog_ch=toggle;
command_tx=10;
menu30_2=2;
goto f;
}

if ((rem_command != 55)&&(menu30_2==2 )) {menu30_2=0;};
if ((tek_menu==30)&&(rem_command == 55)&&(menu30_2==2 )) {
tog_ch=toggle;
command_tx=10;
menu30_2=0;
Refr30=0;
go_to_menu(0);		
}

f:
} 

if ((command_tx==20)&&(tek_menu==65)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  go_to_menu(29); break;
case 33 :  go_to_menu(5);  break;
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(1); break;
case 16:   go_to_menu(66); break;
case 59:   go_to_menu(66); break;
};   
} 

if ((command_tx==20)&&(tek_menu==65)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  go_to_menu(29); break;
case 33 :  go_to_menu(5);  break;
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(1); break;
case 16:   go_to_menu(66); break;
case 59:   go_to_menu(66); break;
};   
} 

if (tek_menu>=31) {	

if ((command_tx==20)&&(tek_menu==66)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  go_to_menu(69); break;
case 33 :  go_to_menu(67);  break;
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(65); break;
case 16:   go_to_menu(31); LCD_clear(); break;
case 59:   go_to_menu(31); break;
};   
} 

if ((command_tx==20)&&(tek_menu==67)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  go_to_menu(66); break;
case 33 :  go_to_menu(68);  break;
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(65); break;
case 16:   go_to_menu(46); break;
case 59:   go_to_menu(46); break;
};   
} 

if ((command_tx==20)&&(tek_menu==68)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  go_to_menu(67); break;
case 33 :  go_to_menu(69);  break;
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(65); break;
case 16:   go_to_menu(55); break;
case 59:   go_to_menu(55); break;
};   
} 

if ((command_tx==20)&&(tek_menu==69)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  go_to_menu(68); break;
case 33 :  go_to_menu(66);  break;
case 48:  go_to_menu(0); break;
case 34:  go_to_menu(65); break;
case 16:   go_to_menu(63); break;
case 59:   go_to_menu(63); break;
};   
} 

if ((command_tx==20)&&(tek_menu==63)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :		d_count=0; go_to_menu(64); break;
case 33 :	d_count=0; go_to_menu(64);  break;
case 48:	d_count=0; go_to_menu(0); break;
case 34:	d_count=0; go_to_menu(menu_temp); break;
case 17:	d_count=0; go_to_menu(menu_temp); break;
};   
} 

if ((command_tx==20)&&(tek_menu==64)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  d_count=0; go_to_menu(63); break;
case 33 :  d_count=0; go_to_menu(63);  break;
case 48:  d_count=0; go_to_menu(0); break;
case 34:  d_count=0; go_to_menu(menu_temp); break;
case 17:     d_count=0; go_to_menu(menu_temp); break;
};   
} 

if ((command_tx==20)&&(tek_menu==55)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32	:go_to_menu(62);	break;
case 33	:go_to_menu(56);	break;
case 48	:go_to_menu(0);		break;
case 34:go_to_menu(68);	break;
case 17	:go_to_menu(62);	break;
case 16:go_to_menu(59);		break;
case 59:go_to_menu(63);		break;
};   
} 

if ((command_tx==20)&&(tek_menu==56)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32 :  go_to_menu(55);		break;
case 33 :  go_to_menu(57);	break;
case 48:  go_to_menu(0);		break;
case 34:  go_to_menu(68);	break;
case 17:     go_to_menu(60);	break;
case 16:   go_to_menu(60);	break;
case 59:   go_to_menu(64);		break;
};   
} 

if ((command_tx==20)&&(tek_menu==57)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32	:go_to_menu(56);	break;
case 33	:go_to_menu(58);	break;
case 48	:go_to_menu(0);		break;
case 34:go_to_menu(68);	break;
case 17	:go_to_menu(61);	break;
case 16:go_to_menu(61);		break;
case 59:go_to_menu(64);		break;
};   
} 

if ((command_tx==20)&&(tek_menu==58)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32	:go_to_menu(57);	break;
case 33	:go_to_menu(59);	break;
case 48	:go_to_menu(0);		break;
case 34:go_to_menu(68);	break;
case 17	:go_to_menu(62);	break;
case 16:go_to_menu(62);		break;
case 59:go_to_menu(64);		break;
};   
} 

if ((command_tx==20)&&(tek_menu==59)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32	:go_to_menu(58);	break;
case 33	:go_to_menu(60);	break;
case 48	:go_to_menu(0);		break;
case 34:go_to_menu(68);	break;
case 17	:go_to_menu(55);	break;
case 16:go_to_menu(55);		break;
case 59:go_to_menu(64);		break;
};   
} 

if ((command_tx==20)&&(tek_menu==60)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32	:go_to_menu(59);	break;
case 33	:go_to_menu(61);	break;
case 48	:go_to_menu(0);		break;
case 34:go_to_menu(68);	break;
case 17	:go_to_menu(56);	break;
case 16:go_to_menu(56);		break;
case 59:go_to_menu(64);		break;
};   
} 

if ((command_tx==20)&&(tek_menu==61)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32	:go_to_menu(60);	break;
case 33	:go_to_menu(62);	break;
case 48	:go_to_menu(0);		break;
case 34:go_to_menu(68);	break;
case 17	:go_to_menu(57);	break;
case 16:go_to_menu(57);		break;
case 59:go_to_menu(64);		break;
};   
} 

if ((command_tx==20)&&(tek_menu==62)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32	:go_to_menu(61);	break;
case 33	:go_to_menu(55);	break;
case 48	:go_to_menu(0);		break;
case 34:go_to_menu(68);	break;
case 17	:go_to_menu(58);	break;
case 16:go_to_menu(55);		break;
case 59:go_to_menu(64);		break;
};   
} 

if ((command_tx==20)&&(tek_menu==46)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32	:go_to_menu(54);	break;
case 33	:go_to_menu(47);	break;
case 48	:go_to_menu(0);		break;
case 34:go_to_menu(67);	break;
case 17	:go_to_menu(47);	break;
case 16:go_to_menu(47);		break;
};   
} 

if ((command_tx==20)&&(tek_menu==47)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32	:go_to_menu(46);	break;
case 33	:go_to_menu(48);	break;
case 48	:go_to_menu(0);		break;
case 34:go_to_menu(67);	break;
case 17	:go_to_menu(54);	break;
case 16:go_to_menu(51);		break;
case 59:go_to_menu(64);		break;
};   
} 

if ((command_tx==20)&&(tek_menu==48)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32	:go_to_menu(47);	break;
case 33	:go_to_menu(49);	break;
case 48	:go_to_menu(0);		break;
case 34:go_to_menu(67);	break;
case 17	:go_to_menu(52);	break;
case 16:go_to_menu(52);		break;
case 59:go_to_menu(64);		break;
};   
} 

if ((command_tx==20)&&(tek_menu==49)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32	:go_to_menu(48);	break;
case 33	:go_to_menu(50);	break;
case 48	:go_to_menu(0);		break;
case 34:go_to_menu(67);	break;
case 17	:go_to_menu(53);	break;
case 16:go_to_menu(53);		break;
case 59:go_to_menu(64);		break;
};   
} 

if ((command_tx==20)&&(tek_menu==50)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32	:go_to_menu(49);	break;
case 33	:go_to_menu(51);	break;
case 48	:go_to_menu(0);		break;
case 34:go_to_menu(67);	break;
case 17	:go_to_menu(54);	break;
case 16:go_to_menu(54);		break;
case 59:go_to_menu(64);		break;
};   
} 

if ((command_tx==20)&&(tek_menu==51)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32	:go_to_menu(50);	break;
case 33	:go_to_menu(52);	break;
case 48	:go_to_menu(0);		break;
case 34:go_to_menu(67);	break;
case 17	:go_to_menu(47);	break;
case 16:go_to_menu(47);		break;
case 59:go_to_menu(64);		break;
};   
} 

if ((command_tx==20)&&(tek_menu==52)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32	:go_to_menu(51);	break;
case 33	:go_to_menu(53);	break;
case 48	:go_to_menu(0);		break;
case 34:go_to_menu(67);	break;
case 17	:go_to_menu(48);	break;
case 16:go_to_menu(48);		break;
case 59:go_to_menu(64);		break;
};   
} 

if ((command_tx==20)&&(tek_menu==53)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32	:go_to_menu(52);	break;
case 33	:go_to_menu(54);	break;
case 48	:go_to_menu(0);		break;
case 34:go_to_menu(67);	break;
case 17	:go_to_menu(49);	break;
case 16:go_to_menu(49);		break;
case 59:go_to_menu(64);		break;
};   
} 

if ((command_tx==20)&&(tek_menu==54)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32	:go_to_menu(53);	break;
case 33	:go_to_menu(47);	break;
case 48	:go_to_menu(0);		break;
case 34:go_to_menu(67);	break;
case 17	:go_to_menu(50);	break;
case 16:go_to_menu(50);		break;
case 59:go_to_menu(64);		break;
};   
} 

if ((command_tx==20)&&(tek_menu==31)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32	:go_to_menu(38);	break;
case 33	:go_to_menu(32);	break;
case 48	:go_to_menu(0);		break;
case 34:go_to_menu(66);	break;
case 17	:go_to_menu(66);	break;
case 16:go_to_menu(66);		break;
};   
} 

if ((command_tx==20)&&(tek_menu>=32)&&(tek_menu<=38)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 32	:go_to_menu((tek_menu-1));	break;
case 33	:   if(tek_menu==38){go_to_menu(31);} else {go_to_menu((tek_menu+1));};	break;
case 48	:go_to_menu(0);		break;
case 34:go_to_menu(66);	break;
case 17	:go_to_menu(66);	break;
case 16:go_to_menu((tek_menu+7));		break;
case 59:go_to_menu(64);		break;
};   
} 

if ((command_tx==20)&&(tek_menu>=39)&&(tek_menu<=45)&&(tog_ch!=toggle)) {   
switch ( rem_command) {    
case 34:go_to_menu((tek_menu-7));	break;
case 17:go_to_menu((tek_menu-7));		break;
case 59:go_to_menu((tek_menu-7));		break;
};   
} 

}
}   
void sync_clock (void) {                 
rtc_get_time(&h,&m,&s); 
hour=h;
min=m;
sec=s;
}

void DS1307_init (void) {                
if (DS!=34) {
rtc_init(0,1,0);        
rtc_set_time(0,15,0); 
rtc_set_date(1,1,1) ; 
DS=34;    
}
} 

void vnutr_chasi (void) { 
displ_refresh=1;
sync_clock();
}
void treble_swich (void) {
if (treble<=7) {  
com=112+treble;
tda7313_write(com);}  
if ((treble>7)&&(treble<=14)) {  
com=134-treble;
tda7313_write(com);
}  
}

void bass_swich (void) {
if (bass<=7) {  
com=96+bass;
tda7313_write(com);}  
if ((bass>7)&&(bass<=14)) {  
com=118-bass;
tda7313_write(com);
}  
}

void set_parameters (void) {     

if ((command_tx==20)&&(tek_menu==5)) {  
if ((rem_command==22)&& (volume_ogr>0)) {
volume_ogr--;
command_tx=10;
displ_refresh=1;
goto n1;
}
if ((rem_command==21)&& (volume_ogr<63)) {
volume_ogr++;
command_tx=10;
displ_refresh=1;
goto n1;
}
}

if ((command_tx==20)&&(tek_menu==6)) {  
if ((rem_command==22)&& (volume_on_max>0)) {
volume_on_max--;
command_tx=10;
displ_refresh=1;
goto n1;
}
if ((rem_command==21)&& (volume_on_max<63)) {
volume_on_max++;
command_tx=10;
displ_refresh=1;
goto n1;
}
}

if ((command_tx==20)&&(tek_menu==7)) {  
if ((rem_command==22)&& (att>0)) {
att--;
command_tx=10;
displ_refresh=1;
goto n1;
}
if ((rem_command==21)&& (att<31)) {
att++;
command_tx=10;
displ_refresh=1;
goto n1;
}
}

if ((command_tx==20)&&(tek_menu==8)&&(tog_ch!=toggle)) {  
Refr4=1;          

switch ( tek_vhod) {                                                     
case 1: loudness=loudness1;   break;
case 2: loudness=loudness2;   break;
case 3: loudness=loudness3;   break;
};

if ((rem_command==22)&& (loudness<3)) {
loudness++;                       
if (tek_vhod==1) { 
switch ( loudness) {    
case 1:   tda7313_write(80);  loudness1=loudness;  displ_refresh=1;  break;          
case 2:   tda7313_write(72);  loudness1=loudness;  displ_refresh=1;  break;
case 3:   tda7313_write(64);  loudness1=loudness;  displ_refresh=1;  break;
};   
} 
if (tek_vhod==2) { 
switch ( loudness) {    
case 1:   tda7313_write(81); loudness2=loudness;  displ_refresh=1;  break;
case 2:   tda7313_write(73); loudness2=loudness;  displ_refresh=1;  break;
case 3:   tda7313_write(65); loudness2=loudness;  displ_refresh=1;  break;
};   
} 
if (tek_vhod==3) { 
switch ( loudness) {    
case 1:   tda7313_write(82); loudness3=loudness;  displ_refresh=1;  break;
case 2:   tda7313_write(74); loudness3=loudness;  displ_refresh=1; break;
case 3:   tda7313_write(66); loudness3=loudness;  displ_refresh=1;  break;
};   
} 
tog_ch=toggle;
command_tx=10;
goto n1;
}

if ((rem_command==21)&& (loudness>0)&&(tog_ch!=toggle)) {
loudness--;
if (tek_vhod==1) { 
switch ( loudness) {    
case 0:   tda7313_write(88); loudness1=loudness; displ_refresh=1;  break;
case 1:   tda7313_write(80); loudness1=loudness; displ_refresh=1;  break;
case 2:   tda7313_write(72); loudness1=loudness; displ_refresh=1;  break;
};   
} 
if (tek_vhod==2) { 
switch ( loudness) {    
case 0:   tda7313_write(89); loudness2=loudness; displ_refresh=1;  break;
case 1:   tda7313_write(81); loudness2=loudness; displ_refresh=1;  break;
case 2:   tda7313_write(73); loudness2=loudness; displ_refresh=1;  break;
};   
} 
if (tek_vhod==3) { 
switch ( loudness) {    
case 0:   tda7313_write(90); loudness3=loudness; displ_refresh=1;  break;
case 1:   tda7313_write(82); loudness3=loudness; displ_refresh=1;  break;
case 2:   tda7313_write(74); loudness3=loudness; displ_refresh=1;  break;
};   
} 
tog_ch=toggle;
command_tx=10;
goto n1;
}
}

if ((command_tx==20)&&(tek_menu==9)) {      

switch ( tek_vhod) {
case 1:  treble=treble1;   break;
case 2:  treble=treble2;   break;
case 3:  treble=treble3;  break;
};

if ((rem_command==22)&&(treble<14)&&(tog_ch!=toggle)) {
command_tx=10;   
tog_ch=toggle; 
treble++;          

switch ( tek_vhod) {                    
case 1:  treble1=treble;   break;
case 2:  treble2=treble;   break;
case 3:  treble3=treble;  break;
};

displ_refresh=1;

treble_swich ();
goto n1;
}

if ((rem_command==21)&&(treble>0)&&(tog_ch!=toggle)) {
command_tx=10;   
tog_ch=toggle; 
treble--;          

switch ( tek_vhod) {                    
case 1:  treble1=treble;   break;
case 2:  treble2=treble;   break;
case 3:  treble3=treble;  break;
};

displ_refresh=1;

treble_swich ();
goto n1;
}
} 

if ((command_tx==20)&&(tek_menu==10)) {      

switch ( tek_vhod) {
case 1:  bass=bass1;   break;
case 2:  bass=bass2;   break;
case 3:  bass=bass3;  break;
};

if ((rem_command==22)&&(bass<14)&&(tog_ch!=toggle)) {
command_tx=10;   
tog_ch=toggle; 
bass++;          

switch ( tek_vhod) {                    
case 1:   bass1= bass;   break;
case 2:   bass2= bass;   break;
case 3:   bass3= bass;  break;
};

displ_refresh=1;

bass_swich ();
goto n1;
}
if ((rem_command==21)&&(bass>0)&&(tog_ch!=toggle)) {
command_tx=10;   
tog_ch=toggle; 
bass--;          

switch ( tek_vhod) {                    
case 1:   bass1= bass;   break;
case 2:   bass2= bass;   break;
case 3:   bass3= bass;  break;
};

displ_refresh=1;

bass_swich ();
goto n1;
}
}

if ((command_tx==20)&&(tek_menu==11)&&(tog_ch!=toggle)) {  
if ((rem_command==22)&& (date<31)) {
date++;
displ_refresh=1;
rtc_set_date(date,mounth,year) ;
command_tx=10;
tog_ch=toggle;
}
if ((rem_command==21)&& (date>1)) {
date--;
displ_refresh=1;
rtc_set_date(date,mounth,year) ;
command_tx=10;
tog_ch=toggle;
}
goto n1;
}

if ((command_tx==20)&&(tek_menu==12)&&(tog_ch!=toggle)) {  
if ((rem_command==22)&& (mounth<12)) {
mounth++;
displ_refresh=1;
rtc_set_date(date,mounth,year) ;
command_tx=10;
tog_ch=toggle;
}
if ((rem_command==21)&& (mounth>1)) {
mounth--;
displ_refresh=1;
rtc_set_date(date,mounth,year) ;
command_tx=10;
tog_ch=toggle;
}
goto n1;
}

if ((command_tx==20)&&(tek_menu==13)&&(tog_ch!=toggle)) {  
if ((rem_command==22)&& (year<55)) {
year++;
displ_refresh=1;
rtc_set_date(date,mounth,year) ;
command_tx=10;
tog_ch=toggle;
}
if ((rem_command==21)&& (year>8)) {
year--;
displ_refresh=1;
rtc_set_date(date,mounth,year) ;
command_tx=10;
tog_ch=toggle;
}
goto n1;
}

if ((command_tx==20)&&(tek_menu==14)&&(tog_ch!=toggle)) {  
if ((rem_command==22)&& (h<24)) {
h++;
displ_refresh=1;
if (h==24) {h=0;}
rtc_set_time(h,m,s);
command_tx=10;
tog_ch=toggle;
hour=h;
min=m;
}

if ((rem_command==21)&& (h==0)) {h=23; displ_refresh=1;  rtc_set_time(h,m,s); hour=h;  min=m; command_tx=10; tog_ch=toggle;  goto n1;}

if ((rem_command==21)&& (h>0)) {
h--;
displ_refresh=1;
rtc_set_time(h,m,s);
command_tx=10;
tog_ch=toggle;
hour=h;
min=m;
}
goto n1;
}

if ((command_tx==20)&&(tek_menu==15)&&(tog_ch!=toggle)) {  
if ((rem_command==22)&& (m<60)) {
m++;
displ_refresh=1;
if (m==60) {m=0;}
rtc_set_time(h,m,s);
command_tx=10;
tog_ch=toggle;
hour=h;
min=m;
}

if ((rem_command==21)&& (m==0)) {m=59; rtc_set_time(h,m,s); hour=h;  min=m; command_tx=10; tog_ch=toggle;  goto n1;}

if ((rem_command==21)&& (m>0)) {
m--;
displ_refresh=1;
rtc_set_time(h,m,s);
command_tx=10;
tog_ch=toggle;
hour=h;
min=m;
}
goto n1;
}

if ((command_tx==20)&&(tek_menu==16)&&(tog_ch!=toggle)) {  
if ((rem_command==22)&& (s<60)) {
s++;
displ_refresh=1;
if (s==60) {s=0;}
rtc_set_time(h,m,s);
command_tx=10;
tog_ch=toggle;
hour=h;
min=m;
}

if ((rem_command==21)&& (s==0)) {s=59; rtc_set_time(h,m,s); hour=h;  min=m; command_tx=10; tog_ch=toggle;  goto n1;}

if ((rem_command==21)&& (s>0)) {
s--;
displ_refresh=1;
rtc_set_time(h,m,s);
command_tx=10;
tog_ch=toggle;
hour=h;
min=m;
}
goto n1;
}

if ((command_tx==20)&&(tek_menu==19))  {  
if (rem_command==22) {
hour_on++;
displ_refresh=1;
if (hour_on>=24)  {hour_on=0;}
command_tx=10;
goto n1;
}
if ((rem_command==21)&&(hour_on==0)) {hour_on=23; command_tx=10; displ_refresh=1;  goto n1;}
if ((rem_command==21)&&(hour_on>0)) {
hour_on--;
displ_refresh=1;
command_tx=10;
goto n1;
}
} 

if ((command_tx==20)&&(tek_menu==20))  {  
if (rem_command==22) {
min_on ++;
displ_refresh=1;
if (min_on>=60)  {min_on=0;}
command_tx=10;
goto n1;
}
if ((rem_command==21)&&(min_on==0)) {min_on=59; command_tx=10; displ_refresh=1;  goto n1;}
if ((rem_command==21)&&(min_on>=1)) {
min_on--;
displ_refresh=1;
command_tx=10;
goto n1;
}
} 

if ((command_tx==20)&&(tek_menu==22))  {  
if (rem_command==22) {
hour_off++;
displ_refresh=1;
if (hour_off>=24)  {hour_off=0;}
command_tx=10;
goto n1;
}
if ((rem_command==21)&&(hour_off==0)) {hour_off=23; command_tx=10; displ_refresh=1; goto n1;}
if ((rem_command==21)&&(hour_off>0)) {
hour_off--;
displ_refresh=1;
command_tx=10;
goto n1;
}
} 

if ((command_tx==20)&&(tek_menu==23))  {  
if (rem_command==22) {
min_off++;
displ_refresh=1;
if (min_off>=60)  {min_off=0;}
command_tx=10;
goto n1;
}
if ((rem_command==21)&&(min_off==0)) {min_off=59; command_tx=10; displ_refresh=1; goto n1;}
if ((rem_command==21)&&(min_off>0)) {
min_off--;
displ_refresh=1;
command_tx=10;
goto n1;
}
} 

if ((command_tx==20)&&(tek_menu==24))  {  
if (rem_command==22) {
hour_off++;
displ_refresh=1;
if (hour_off>=24)  {hour_off=0;}
command_tx=10;
goto n1;
}
if ((rem_command==21)&&(hour_off==0)) {hour_off=23; command_tx=10; displ_refresh=1; goto n1;}
if ((rem_command==21)&&(hour_off>0)) {
hour_off--;
displ_refresh=1;
command_tx=10;
goto n1;
}
} 

if ((command_tx==20)&&(tek_menu==25))  {  
if (rem_command==22) {
min_off++;
displ_refresh=1;
if (min_off>=60)  {min_off=0;}
command_tx=10;
goto n1;
}
if ((rem_command==21)&&(min_off==0)) {min_off=59; command_tx=10; displ_refresh=1; goto n1;}
if ((rem_command==21)&&(min_off>0)) {
min_off--;
displ_refresh=1;
command_tx=10;
goto n1;
}
} 

if ((command_tx==20)&&(tek_menu==27))  {  
if (rem_command==22) {
hour_on++;
displ_refresh=1;
if (hour_on>=24)  {hour_on=0;}
command_tx=10;
goto n1;
}
if ((rem_command==21)&&(hour_on==0)) {hour_on=23; command_tx=10; displ_refresh=1; goto n1;}
if ((rem_command==21)&&(hour_on>0)) {
hour_on--;
displ_refresh=1;
command_tx=10;
goto n1;
}
} 

if ((command_tx==20)&&(tek_menu==28))  {  
if (rem_command==22) {
min_on++;
displ_refresh=1;
if (min_on>=60)  {min_on=0;}
command_tx=10;
goto n1;
}
if ((rem_command==21)&&(min_on==0)) {min_on=59; command_tx=10;displ_refresh=1; goto n1;}
if ((rem_command==21)&&(min_on>0)) {
min_on--;
displ_refresh=1;
command_tx=10;
goto n1;
}
} 

if ((command_tx==20)&&(tek_menu==29)&&(tog_ch!=toggle))  {  
if ((rem_command==22)&&(valcoder_sens<8)) {
valcoder_sens++;
displ_refresh=1;
n_valc_imp=10-valcoder_sens;
tog_ch=toggle;
command_tx=10;
goto n1;
}

if ((rem_command==21)&&(valcoder_sens>0)) {
valcoder_sens--;
displ_refresh=1;
n_valc_imp=10-valcoder_sens;
tog_ch=toggle;
command_tx=10;
goto n1;
}
} 

if ((command_tx==20)&&(tek_menu==63)&&(tog_ch!=toggle))  {  

if(rem_command==10) {dig1=0; dig2=0; dig3=0; dig4=0; dig5=0; d_count=0; adr_long=0; }; 	
if (d_count>5) {d_count=0;};		
if((rem_command>9)&&(rem_command!=59)) {goto e;};

if ((rem_command>=0)&&(rem_command<=9)) {
switch (d_count) {
case 0 : dig1=rem_command;  break;
case 1 : dig2=rem_command;  break;
case 2 : dig3=rem_command;  break;
case 3 : dig4=rem_command;  break;
case 4 : dig5=rem_command;  break;
case 5 : adr_long=(long int) rem_command; d_count=0; goto k; break;
};
d_count++;

}

switch (d_count) {
case 1 : adr_long=(long int)dig1; goto k;  break;
case 2 : adr_long=(long int)dig1*10 + (long int)dig2; goto k;  break;
case 3 : adr_long=(long int)dig1*100 + (long int)dig2*10 + (long int)dig3; goto k;  break;
case 4 : adr_long=(long int)dig1*1000 + (long int)dig2*100 + (long int)dig3*10 + (long int)dig4; goto k;  break;
case 5 : adr_long=(long int)dig1*10000 + (long int)dig2*1000 + (long int)dig3*100 + (long int)dig4*10 + (long int)dig5;  break;
};

k:
if (rem_command==22) {adr_long++;};
if (rem_command==21) {adr_long--;};

if(adr_long>655 ) {adr_long=0;};			

address_temp=(unsigned int)adr_long;		

if (rem_command==59) {
res_temp = read_from_AD7142_spi (address_temp);	
d_count=0;
};
displ_refresh=1;
tog_ch=toggle;
command_tx=10;
goto n1;

e:
} 

if ((command_tx==20)&&(tek_menu==64)&&(tog_ch!=toggle))  {  

if(rem_command==10) {dig1=0; dig2=0; dig3=0; dig4=0; dig5=0; d_count=0; res_long=0; }; 	
if (d_count>5) {d_count=0;};		
if((rem_command>9)&&(rem_command!=59)) {goto f;};

if ((rem_command>=0)&&(rem_command<=9)) {
switch (d_count) {
case 0 : dig1=rem_command;  break;
case 1 : dig2=rem_command;  break;
case 2 : dig3=rem_command;  break;
case 3 : dig4=rem_command;  break;
case 4 : dig5=rem_command;  break;
case 5 : res_long=(long int) rem_command; d_count=0; goto g; break;
};
d_count++;

}

switch (d_count) {
case 1 : res_long=(long int)dig1; goto g;  break;
case 2 : res_long=(long int)dig1*10 + (long int)dig2; goto g;  break;
case 3 : res_long=(long int)dig1*100 + (long int)dig2*10 + (long int)dig3; goto g;  break;
case 4 : res_long=(long int)dig1*1000 + (long int)dig2*100 + (long int)dig3*10 + (long int)dig4; goto g;  break;
case 5 : res_long=(long int)dig1*10000 + (long int)dig2*1000 + (long int)dig3*100 + (long int)dig4*10 + (long int)dig5;  break;
};

g:

if (rem_command==22) {res_long++;};
if (rem_command==21) {res_long--;};
if(res_long>65535) {res_long=0;};
res_temp=(unsigned int)res_long;		

if (rem_command==59) {
write_to_AD7142_spi(address_temp,res_temp);
d_count=0;
if ((address_temp>=0)&&(address_temp<=7)) {AD7142_Config [address_temp]=res_temp;};
if ((address_temp>=128)&&(address_temp<=223)) {AD7142_Config [(address_temp-120)]=res_temp;};

};

displ_refresh=1;
tog_ch=toggle;
command_tx=10;
goto n1;

f:
} 

if ((command_tx==20)&&(tog_ch!=toggle)&&(tek_menu==31))  {  
if(rem_command==10) {dig1=0; dig2=0; dig3=0; dig4=0; dig5=0; d_count=0; };
if (d_count>2) {d_count=0;};		

if ((rem_command>=0)&&(rem_command<=9)) {
switch (d_count) {
case 0 : dig1=rem_command;  break;
case 1 : dig2=rem_command;  break;
case 2 : stage_temp=(unsigned  int) rem_command; d_count=0; goto u; break;
};
d_count++;

}

switch (d_count) {
case 1 : stage_temp=(unsigned  int)dig1; goto u;  break;
case 2 : stage_temp=(unsigned  int)dig1*10 + (unsigned  int)dig2; break;
};
u:
if (rem_command==22) {stage_temp++;};
if (rem_command==21) {stage_temp--;};
if (stage_temp>11) {stage_temp=0;};

if (rem_command==59) {stage = stage_temp;};

displ_refresh=1;
tog_ch=toggle;
command_tx=10;

} 

if ((command_tx==20)&&(tog_ch!=toggle)&&(tek_menu==46))  {  
if(rem_command==10) {dig1=0; dig2=0; dig3=0; dig4=0; dig5=0; d_count=0; };
if (d_count>2) {d_count=0;};		

if ((rem_command>=0)&&(rem_command<=9)) {
switch (d_count) {
case 0 : dig1=rem_command;  break;
case 1 : dig2=rem_command;  break;
case 2 : stage_temp=(unsigned  int) rem_command; d_count=0; goto u1; break;
};
d_count++;

}

switch (d_count) {
case 1 : stage_temp=(unsigned  int)dig1; goto u;  break;
case 2 : stage_temp=(unsigned  int)dig1*10 + (unsigned  int)dig2; break;
};
u1:
if (rem_command==22) {stage_temp++;};
if (rem_command==21) {stage_temp--;};
if (stage_temp>11) {stage_temp=0;};

if (rem_command==59) {stage = stage_temp;};

displ_refresh=1;
tog_ch=toggle;
command_tx=10;

} 

n1:
}   
void povt_deistv (void) {            
tog_ch=toggle;
displ_refresh=1; 
Refr4=1;          
switch ( tek_vhod) {
case 1: bass=bass1; treble= treble1; treble_swich(); bass_swich();   break; 
case 2: bass=bass2; treble= treble2; treble_swich(); bass_swich();    break;
case 3: bass=bass3; treble= treble3; treble_swich(); bass_swich();    break;
}
}

void tda_control (void){     
if ((command_tx==20)&&(tek_menu==0)) {                     
#asm("cli")     
if ((volume> volume_ogr)&&(rem_command==16)&&(volume>0)) {   
volume--;                                                                                                                  
tda7313_write(volume);                                                                                        
command_tx=10;                                                                                                    
displ_refresh=1;    
Refr2=1;  
goto m4;                                                                                                                  
};     
if ((volume< 63)&&(rem_command==17)) {    
volume++;                                                                                                                  
tda7313_write(volume);                                                                                        
command_tx=10;                                                                                                    
displ_refresh=1;   
Refr2=1;  
goto m4;                                                                                                                  
} ; 

if ((rem_command==1)&&(tog_ch!=toggle)) {         
tek_vhod=1;
switch ( loudness1) {    
case 0:   tda7313_write(88); povt_deistv ();  goto m4;  
case 1:   tda7313_write(80); povt_deistv ();  goto m4; 
case 2:   tda7313_write(72); povt_deistv ();  goto m4;
case 3:   tda7313_write(64); povt_deistv ();  goto m4;
};   
}; 
if ((rem_command==2)&&(tog_ch!=toggle)) {         
tek_vhod=2;
switch ( loudness2) {    
case 0:   tda7313_write(89); povt_deistv (); goto m4;  
case 1:   tda7313_write(81); povt_deistv (); goto m4; 
case 2:   tda7313_write(73); povt_deistv (); goto m4;
case 3:   tda7313_write(65); povt_deistv (); goto m4;
};   
}; 
if ((rem_command==3)&&(tog_ch!=toggle)) {         
tek_vhod=3;
switch ( loudness3) {    
case 0:   tda7313_write(90); povt_deistv (); goto m4;  
case 1:   tda7313_write(82); povt_deistv (); goto m4; 
case 2:   tda7313_write(74); povt_deistv (); goto m4;
case 3:   tda7313_write(66); povt_deistv (); goto m4;
};   
}; 
if ((rem_command==13)&&(tog_ch!=toggle)) {         
tog_ch=toggle;
if (att_on==0) {     
tda7313_write(att+128);   
tda7313_write(att+160);   
att_on=1;                                  
command_tx=10;              
displ_refresh=1;   
Refr4=1; 
goto m4;                             
}  
else { 
tda7313_write(128);            
tda7313_write(160);            
att_on=0;                               
command_tx=10;              
displ_refresh=1;  
Refr4=1; 
};
}; 
#asm("sei")    
};  
m4:
#asm("sei")    
}    
void system_init (void) {  
if (first_run!=25) {                 
displ_refresh=1;
hour_on=0;
min_on = 0;
volume_ogr=30;
valcoder_sens=5;                        
n_valc_imp=10-valcoder_sens;  
save_volume = 44;                       
volume_on_max=30;
tek_menu=0; 			
loudness=0;                                 
loudness1=0;                                 
loudness2=0;                                 
loudness3=0;                                 

tek_vhod=1;                                
att=25;                                           
treble=7;                                      
treble1=7;                                      
treble2=7;                                      
treble3=7;                                      

bass=7;                                          
bass1=7;                                          
bass2=7;                                          
bass3=7;                                          

tog_ch=0;
amp_on_act=0;						
amp_off_act=0;						
system_on=0;						

DS=12;                                                                          
first_run=25;

} 
}

void amplifier_on (void) { 
if ((system_on==0)&&(command_tx==20)&&(rem_command==12)&&(tog_ch!=toggle)) {  
system_on=1;    
Refr4=1  ;

if (volume_on_max>=63) {volume_on_max=30;};
if (volume_ogr>=63) {volume_ogr=30;};
PORTB |=(1<<0);;			        

Display_ON();        
LCD_init();            
LCD_clear();   
delay_ms(2000);   

if (loudness1>=4)  {loudness1=0;}; 
if (loudness2>=4)  {loudness2=0;};
if (loudness3>=4)  {loudness3=0;};
if (save_volume>=64) {save_volume=44;}
if (volume_on_max>=64) {volume_on_max=44;}

amp_on_act=0;

tek_menu=0;  
switch (tek_vhod) {    
case 1:  rem_command=1;  break;             
case 2:  rem_command=2;  break;
case 3:  rem_command=3;  break;
};
tda_control ();              

if (save_volume>=volume_on_max) {    
volume= save_volume; tda7313_write(volume);     
}
else { volume=volume_on_max; tda7313_write(volume);   }; 

PORTB |=(1<<3);	  
PORTB |=(1<<1);;	 
PORTD |=(1<<5);;		  
}
}

void amplifier_off(void) {  
if ((system_on==1)&&(command_tx==20)&&(rem_command==12)&&(tog_ch!=toggle)) {  
PORTD &=~(1<<5);;		      
system_on=0;    

amp_off_act=0; 

if (volume>=volume_on_max) {             
save_volume=volume;                                
}
else {save_volume=volume_on_max;};
LCD_clear();
Display_OFF();
PORTB &=~(1<<3);	
PORTB &=~(1<<1);;	
delay_ms(500);
PORTB &=~(1<<0);;			
tog_ch=toggle;
command_tx=10;
}
} 

void auto_ON (void) {  
if (amp_on_act==1){    
if ((hour_on==hour)&&(min_on==min)&&(system_on==0)){   
command_tx=20;                                                                                                             
rem_command=12;
tog_ch=1;
toggle=0;
amp_on_act=0; 
} 
}  
} 

void auto_OFF (void) { 
if ((amp_off_act==1)&&(tek_menu<17)){  
if ((hour_off==hour)&&(min_off==min)&&(system_on==1)){   
command_tx=20;                                                                                                             
rem_command=12;
tog_ch=1;
toggle=0;
amp_off_act=0; 
} 

} 
}
void valcoder (void) {

if (PIND.4==0) {                   
valcoder_PLUS ++;                
valcoder_MINUS=0;              

if ((valcoder_PLUS== n_valc_imp)&&(tek_menu==0)) {             
valcoder_PLUS=0;   
command_tx=20;                                                                                                             
rem_command=16;
displ_refresh=1;
timer=0;        
} 

if ((valcoder_PLUS== n_valc_imp)&&(tek_menu!=0)) {	
valcoder_PLUS=0;								
command_tx=20;								
rem_command=22;
displ_refresh=1;
tog_ch=1;
toggle=0;
timer=0;        
} 
}

if (PIND.4==1) {  
valcoder_MINUS ++;
valcoder_PLUS=0;

if ((valcoder_MINUS== n_valc_imp)&&(tek_menu==0)) {             
valcoder_MINUS=0;   
command_tx=20;                                                                                                             
rem_command=17;
displ_refresh=1;
timer=0;        
} 

if ((valcoder_MINUS== n_valc_imp)&&(tek_menu!=0)) {             
valcoder_MINUS=0;   
command_tx=20;                                                                                                             
rem_command=21;
displ_refresh=1;
tog_ch=1;
toggle=0;
timer=0;        
} 
}   

}

interrupt [4] void ext_int2_isr(void)
{
#asm ("cli");
SLLI	= read_from_AD7142_spi (8);		
SHLI	= read_from_AD7142_spi (9);		
SCLI	= read_from_AD7142_spi (10);	

if (m1==0) {PORTB |=(1<<1);;	;m1=1; goto w; };
if (m1==1) {PORTB &=~(1<<1);;	;m1=0; };
w:
rem_command = 16;
command_tx=20;
#asm("sei")
}

interrupt [2] void ext_int0_isr(void){ RC5_decoder();}

interrupt [12] void timer0_ovf_isr(void){
char i = 0;			
TCCR0 = 0x00;		
TCNT0 = 0x00;		
counter = 0;		
cnt_bit = 0;			
for (i=0; i<14; i++) code[i]=0; 
}

interrupt [3] void ext_int1_isr(void) {   valcoder ();}

interrupt [8] void timer1_compa_isr(void) {
#asm("cli")
Refr1=1; 
if ((tek_menu>=31)&&(tek_menu<=69)) {timer=0;}
if ((tek_menu!=0)&&(tek_menu!=30)) {timer++;}                      
if (timer>=40) {		
timer=0;			
tek_menu=0;		
displ_refresh=1;		
Refr4=1;			
}

clock=1;  

if (att_on==1) {

if (mig_att==0) {mig_att=1; goto e;}             
if (mig_att==1) {mig_att=0;}
e:
}
#asm("sei")
}

void main(void)
{

init_controller ();

LCD_init();		
LCD_clear();	
i2c_init();		
displ_refresh=1;
DS1307_init();	
timer=0;		
AD7142_configure ();	
#asm("sei")

while (1)

{

if (clock==1) {vnutr_chasi (); clock=0; }              

auto_ON();
auto_OFF ();

if ( tek_menu!=30) {			
amplifier_on();
amplifier_off();
system_init();				
}

if (system_on==1) {			
menu_navi ();
if (tek_menu!=30) { 
tda_control();

set_parameters ();
}
if (displ_refresh==1) {			

display_menu(tek_menu);		
displ_refresh=0; }	   			

}     

}; 
}

