/*****************************************************
   :
 :
1)PORTA     8-  
            "data_port"
      

2)PORTD.6   - /
	2.1)PORTD.7   - /
	2.2)PORTC.2  
	2.3)PORTC.3    1
	2.4)PORTC.4    2
	2.5)PORTC.5  Reset

 3)  *tabstr[]={};       ,     massives.h,
           massives.h
*****************************************************/
#define SET_B0 |=(1<<0);
#define CLR_B0 &=~(1<<0);
#define SET_B1 |=(1<<1);
#define CLR_B1 &=~(1<<1);


#define SET_B2 |=(1<<2);
#define SET_B3 |=(1<<3);
//#define SET_B4 |=(1<<4);
#define SET_B5 |=(1<<5);
#define SET_B6 |=(1<<6);
#define SET_B7 |=(1<<7) ;

#define CLR_B2 &=~(1<<2);
#define CLR_B3 &=~(1<<3);
//#define CLR_B4 &=~(1<<4);
#define CLR_B5 &=~(1<<5);
#define CLR_B6 &=~(1<<6);
#define CLR_B7 &=~(1<<7);

#define Commandi PORTD CLR_B6;		//  
#define Dannie PORTD SET_B6;			//  
#define Write PORTD CLR_B7;			// 
#define Read PORTD SET_B7;			// 
#define Strob_ONE PORTC SET_B2;
#define Strob_ZERO PORTC CLR_B2;
#define CS1_ON PORTC SET_B3;		//  
#define CS1_OFF PORTC CLR_B3;		//  
#define CS2_ON PORTC SET_B4;		//  
#define CS2_OFF PORTC CLR_B4;		//  
#define Res_on PORTC CLR_B5;
#define Res_off PORTC SET_B5;
flash unsigned char *tabstr[]={str_1, str_2, str_3, str_4, str_5, str_6, str_7, str_8, str_9,
 str_10,  str_11,  str_12,  str_13, str_14, str_15, str_16, str_17,str_18, str_19};  //    ,  massives.h






void data_port (unsigned char data) {	//    ,     
PORTA=data;
}
void strob(void) {			//
delay_us(1);
Strob_ONE;					//   /
delay_us(1);				//  ,  450 ,   
Strob_ZERO;				    //  /.         
delay_us(9);				//       /
}
void Display_ON (void) {	// 
Commandi;					//  0-     
Write;						//  R/W-     
data_port(0b00111111);		//   
strob();					//
}
void Display_OFF (void) {		// 
Commandi;					//  0-     
Write;						//  R/W-     
data_port(0b00111110);		//   
strob();					//
}
void LCD_init(void) {			// 
Strob_ZERO;
Res_on;					// . 0   RES
delay_us(2);				// RES
Res_off ;					//  RES
delay_us(11);				// 
Commandi;
Write;

CS1_ON;
CS2_OFF;
data_port(0b11000000);			/*  0 */
strob();
data_port(0b10111000);                        /*   */
strob();
data_port(0b01000000);			/*  0 */
strob();
Display_ON();			/* ,        */

CS1_OFF;
CS2_ON;
data_port(0b11000000);			/*  0 */
strob();
data_port(0b10111000);                        /*   */
strob();
data_port(0b01000000);			/*  0 */
strob();
Display_ON();			/* ,        */
}

void LCD_clear(void) {     /*  1  , .   */
unsigned char i;
unsigned char m;
CS1_ON;
CS2_ON;
for (m=0; m<=7; m++){ //1
Commandi;
Write;
data_port(0b10111000+m);                        /*   */
strob();
data_port(0b01000000+m);			/*  0 */
strob();
Dannie;

for (i=0; i<=64; i++){//2
data_port(0);
strob();
} //2
}//1
}

/*        tabstr*/
void page_kolonka_SL_massiv_nmass_inv_peren (unsigned char page, unsigned char kolonka,  unsigned char SL, unsigned char massiv, unsigned int nmass, unsigned char invert, unsigned char perenos) {  // ,   ,  1  2   1,    SL,     ,    ,   
unsigned char CS1,CS2;
flash unsigned char*stolb=0;
unsigned int i=0;				/* */
unsigned int x=0;				/*     */
unsigned char temp_kolonka;		/*      */
unsigned char temp_page;		/*      */

if (kolonka>=64) {CS1=0; CS2=1; kolonka-=64; }
else {CS1=1; CS2=0;}
temp_kolonka = kolonka;
temp_page = page;
Commandi;
Write;
if (CS1==1){CS1_ON;}			/*/  */
else { CS1_OFF;};
if (CS2==1) {CS2_ON;}			/*/  */
else { CS2_OFF;};
data_port(0b11000000+SL);		/*  */
strob();
data_port(0b10111000+temp_page);	/*   */
strob();
data_port(0b01000000+temp_kolonka);  /* ,       */
strob();
stolb=tabstr[massiv];                                /*    */
Dannie;
Write;
for (i=0; i<=nmass-1; i++){     //1
if (invert==0) {data_port(*stolb); }
if (invert==1) {data_port(~*stolb); }
strob();
stolb++;
x++;
if ((perenos+kolonka)>63) {           //G1           1
if ((x+temp_kolonka)==64){    //G2              
Commandi;                                               /*   */
 CS1_OFF;
 CS2_ON;
data_port(0b10111000+temp_page);	/*     2 */
strob();
data_port(0b01000000);  /*  0     */
strob();
Dannie;                                 /*   */
} //G2
if ((x+temp_kolonka)==(perenos+kolonka)) {   //2                 
CS2_OFF;                                                              //     ,           
CS1_ON;
x=0;
temp_kolonka=kolonka;
Commandi;                                               /*   */
temp_page++;                                           /*  */
data_port(0b10111000+temp_page);        /*   */
strob();                                                     /*   /*/
data_port(0b01000000+temp_kolonka);  /*      .  */
strob();
Dannie;}        //2                                         /*   */
} //G1

else {     //PL
if ((x+temp_kolonka)==(perenos+kolonka)) {   //2
x=0;
temp_kolonka=kolonka;
Commandi;                                               /*   */
temp_page++;                                           /*  */
data_port(0b10111000+temp_page);        /*   */
strob();                                                     /*   /*/
data_port(0b01000000+temp_kolonka);  /*      .  */
strob();
Dannie;}        //2                                         /*   */
}  //PL
};   //1
}








void putstr (unsigned char string[],unsigned char CS1, unsigned char CS2, unsigned char page, unsigned char kolonka, unsigned char SL,unsigned char invert) {
unsigned char a;			//      . 
unsigned char b;			//      . 
unsigned char n;			//  
unsigned char i;				// 1
unsigned char z;			// 2
unsigned char t_sym=0;		//  
unsigned char stroka;			//  
unsigned char tek_kol=0;		// 
unsigned char tek_page=0;		// 
unsigned char crystall=0;		// , , ,    
Commandi;
Write;
if (CS1==1){				///  
CS1_ON;
crystall=1;}
else { CS1_OFF;};
if (CS2==1) {				///  
CS2_ON;
crystall=2;
}
else { CS2_OFF;};
data_port(0b11000000+SL);		//  
strob();
data_port(0b10111000+page);	//   
strob();
data_port(0b01000000+kolonka);	// ,      
strob();
n = strlen(string);
Dannie;
tek_page=page;
tek_kol=kolonka;		//    /

for (i=0; i<n; i++) {	// 	  ,      

if ((string[t_sym] >=47)&&(string[t_sym]<=95)) {	a=0;b=4; stroka= (string[t_sym]-32); goto m1; }
if (string[t_sym] ==58)  {a=2; b=2;  stroka=26;goto m1;  }

if ((string[t_sym] >=34)&&(string[t_sym]<=38)) {	 a=0; b=4; stroka= (string[t_sym]-32);goto m1;  }

if ((string[t_sym] >=39)&&(string[t_sym]<=41)) {	 a=1; b=3; stroka= (string[t_sym]-32);goto m1;  }//         

if ((string[t_sym] >=42)&&(string[t_sym]<=45)) {	 a=0; b=4; stroka= (string[t_sym]-32);goto m1;  }

if (string[t_sym] ==46)  {a=2; b=2;  stroka=14; goto m1; }       //
if ((string[t_sym] >=32)&&(string[t_sym]<=33)) {a=2; b=2; stroka= (string[t_sym]-32);goto m1;  }         //
if (string[t_sym] ==184) {a=0; b=4; stroka=95;goto m1;  }        //
if (string[t_sym] ==168) { a=0; b=4; stroka=94;goto m1;   }	     //
if ((string[t_sym] >=97)&&(string[t_sym]<=126)) {a=0; b=4; stroka= (string[t_sym]-33);goto m1;  } //
if ((string[t_sym] >=192)&&(string[t_sym]<=255)) {a=0; b=4; stroka= (string[t_sym]-96);goto m1; }  //

m1:
for (z=a; z<=b; z++) {//G        z    .     a  b
tek_kol++;
if(tek_kol>=65) {	//X
tek_kol=0;								/*   ,   2 :    1-  2- */
Commandi;								/*    */
Write;
if (crystall==1) {	//Y             /*    ()*/
CS1_OFF;								/* */
CS2_ON;								/* */
crystall=2;								/*       */
data_port(0b10111000+tek_page);				/*      */
strob();
data_port(0b01000000);						/*  ,       */
strob();
Dannie;
}//Y
}//X
if (invert==1) {
data_port(~symbols [stroka] [z] );
strob();  }
else {
data_port(symbols [stroka] [z]) ;
strob(); };
}  //G                  
if (invert==1) {      //    ,   ,   
data_port(255) ;
strob();
}
else {                    //   
data_port(0) ;
strob();
};
tek_kol++;

t_sym++;               /*   */
}/**/
}   // 
